<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');
/**
 * FILE:系统状态-集中监控
 * AUTHOR :zhangjie
 * DATE:2015-04-20
 */
class central_model extends SF_Model {

    /**
     * protobuf object
     */
    protected $_proto = null;
    /**
     * config file
     */
    protected $_conf = '';
    protected $_scinfo_conf = '';


    /**
     * 最大ID号
     */
    protected $_max_id = 0;

    /**
     * max
     */
    protected $_limit_branch = null;
    protected $_limit_sync_cfg = null; //支持一次最多支持同步多少个分支的配置 或 支持一次最多加载多少个分支的AP组配置

    /**
     * message object
     */
    protected $_message = null;
    protected $_wac_role = null;
    protected $_sc_info = null;
    protected $_sc_info_msg = null;
    protected $_old_index = null;
    protected $_old_record = null;
    protected $_used_idset = null;
    protected $_new_idset = null;
    protected $_delete_ids = null;
    protected $_branch_conf = null;
    protected $_branch_record = null;

    protected $_local_wac_conf = '';
    protected $_local_wac_record = '';
    CONST MAC_ID_CNT = 8191;
    CONST SC_SYNCLOG_CNT = 50; //同步日志最多显示前50条
    CONST SC_BINDLOG_CNT = 10; //历史绑定日志最多显示前10条
    CONST REFER_BRANCH_NUM = 50;

    const SC_SYNCLOG = '/var/log/sc.log';//同步日志保存的文件名前缀
    const SC_BINDLOG = '/var/log/sc_bind.log';//sc分支绑定日志
    /**
     * 分支接入点配置的基础目录
     */
    const BRANCH_FOLDER = '/wns/etc/config/wac/branch/';
    /**
     * 分支接入点配置的镜像基础目录
     */
    const BRANCH_MIRROR_FOLDER = '/wns/etc_mirror/wns/etc/config/wac/branch/';

    /**
     * 集中管理分支接入点配置备份目录
     */
    const MGMT_AP_BAK = '/wns/data/webui/sc_bak/';
    /**
     * 临时秘钥生成程序
     */
    const CMD_PWDENC = '/wns/sbin/scpwdenc';
    const HA_BRANCH_FILE = '/wns/etc/config/wac/branch_chg_ha.xml';
    const TRANSFER_APCONF_TASK_DIR = '/tmp/ap_data/';
    const TRANSFER_SWCONF_TASK_DIR = '/tmp/sw_data/';
    const TRANSFER_APCONF_RESULT_DIR = '/tmp/ap_data_err/';
    const TRANSFER_SWCONF_RESULT_DIR = '/tmp/sw_data_err/';

    const PREVIEW_LIMIT = 5;

    public $_import_exceed = false;
    public $_import_exist = 0;
    protected $_mgmt_child_role = null;

    const JS_FILTER_BRANCH_AUTH_TYPE_CENTER = 4;//js 查询集中认证分支传参
    const JS_FILTER_BRANCH_AUTH_TYPE_DISTBT = 5;//js 查询分布式认证分支传参

    const BRANCH_NET_ENABLED_CONF = 'branch_network_config_status.xml';
    const DEFAULT_AES_ENCRYPT_KEY_SUFFIX = 'sundrayupd!@#$%201802061725984';
    const DEFAULT_AES_ENCRYPT_KEY_LEN = 32;
    const FILE_NAME_ENCRYPT_SUFFIX = 'sundrayportalcfg';
    protected $bak_branchs;
    protected $export_file = '';
    protected $export_conf_dir = '';
    protected $export_name = '';

    //新增、导入操作需要判断空间是否不足，这些目录由后台提供
    protected $_related_dir = [
        '/wns/etc/',
        '/wns/etc_mirror/',
    ];

    //需要更新网络接口的分支数组
    protected $_inter_update_branch = array();

    protected $_down_branch_ids = array();

    /**
     * construct
     */
    public function __construct() {
        parent::__construct();
        $this->_limit_branch = $this->get_branch_uplimit();
        $this->_limit_sync_cfg = 25; /*服务支持当前页25个分支同步*/
        require_once(APPPATH.'third_party/wns_phpext/wns_ipc.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_common_enum.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_branch_network.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_sc_info.php');
        require_once(APPPATH.'third_party/proto/msg/webui_msg_wac_sc.php');
        require_once(APPPATH.'third_party/proto/msg/msgid_sc.php');
        require_once(APPPATH.'third_party/proto/msg/msg_tcpproxy.php');
        require_once(APPPATH.'third_party/proto/msg/msgid_tcpproxy.php');
        require_once(APPPATH.'third_party/proto/msg/msgid_ac_realinfo.php');
        require_once(APPPATH.'third_party/proto/conf/sc_common.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_ap.php');
        require_once(APPPATH . 'third_party/proto/conf/dir_chg_ha.php');
        require_once(APPPATH . 'third_party/proto/conf/wns_cfg_wired_policy.php');
        require_once(APPPATH . 'third_party/proto/msg/webui_msg_wac_sc.php');
        $this->_conf = $this->configs['conf_folder'].'wns_cfg_branch_network.xml';
        $this->_scinfo_conf = $this->configs['conf_folder'].'wns_cfg_sc_info.xml';
        $this->_branch_conf = $this->configs['conf_folder'].'branch_info.xml';
        if(is_center_wac())
            $this->_deposit_conf = $this->configs['conf_folder'].'sc_wns_cfg_wl_ap_deposit.xml';
        else
            $this->_deposit_conf = $this->configs['conf_folder'].'wns_cfg_wl_ap_deposit.xml';   
        $this->_center_branch_info = $this->configs['conf_folder'].'center_branch_list.xml';
        $this->_global_pwd_conf = $this->configs['conf_folder'].'sc_global_release_pwd.xml';
        $this->_local_wac_conf = $this->configs['conf_folder'].'sc_wns_cfg_local_wac_network.xml';
        $this->load->model('system_management/admin_account/admin_account_model');
        $this->load->model('sys_configure/central_monitor/sc_disaster_group_model');
        $this->pwdenc_model = $this->admin_account_model;
        $this->export_conf_dir = BRANCH_CONFIG_EXPORT_PAHT;
        build_dir(BRANCH_CONFIG_EXPORT_PAHT);
        build_dir(dirname($this->_conf));
        build_dir(dirname($this->_scinfo_conf));
        build_dir(self::BRANCH_FOLDER);
        $this->_new_idset = [];
        $this->db = get_db_handle('ap');
        $this->_read();
    }

    /**
     * 表单断言
     *
     * @param       $form       array       表单数据
     * @param       $action     string      表单动作(index,query,create,delete,update)
     */
    public function assert_form(array & $form, $action) {
        //供子类定制，在model层对表单进行特殊处理
        parent::assert_form($form, $action);
        switch ($action) {
            case 'index':
            break;
            case 'create':
            break;
            case 'update':
            break;
            case 'delete':
            if (!is_array($this->_args['data'])) {
                $this->_args['data'] = array($this->_args['data']);
            }
            break;
            case 'import':
            break;
            default:
            break;
        }
        $this->log->add('debug', array(
            'opr'    => isset($_REQUEST['opr']) ? $_REQUEST['opr'] : $this->router->fetch_method(),
            'fields' => array_values($this->CI->_list_map()),
            'action' => $action,
            'args'   => $this->_args));
        return true;
    }

    /**
     * 获取列表信息
     */
    protected function get_branch_uplimit()
    {
        $this->load->model('system_maintenance/sn/sn_model');
        return $this->sn_model->get_sn_branch_num();
    }

    /**
     * 获取控制器角色
     */
    public function get_wac_role() {
        return $this->_wac_role;
    }

    public function get_wac_mgmt_role()
    {
        return $this->_mgmt_child_role;
    }

    /**
     * 获取列表信息
     * @param bool $onlyRealBranch 是否只获取实时的分支信息
     */
    public function index($onlyRealBranch = false) {
        //供子类定制
        $this->get_real_branch_list($onlyRealBranch);
        $this->_replace();
        $this->_filter(); //搜索
        $this->_sort(); //排序
        $arr = array_paging($this->_recordset, $this->_args['start'], $this->_args['limit']); //分页
        return $arr;
    }


    /**
     * 获取在线的网点
     * @return array
     */
    public function get_online_branch_list()
    {
        $this->get_real_branch_list();
        $this->_replace();
        $this->_filter();
        return $this->_recordset;
    }


    /**
     * @param bool $onlyRealBranch 是否只获取实时的分支信息
     * @throws Exception
     */
    public function get_real_branch_list($onlyRealBranch = false)
    {
        $realbranchinfo = $auth_center_map = array();
        if(is_center_wac())
        {
            $sendobj = $this->getExpertSearchSendObj();
            $replyobj = new \webui_msg\branch_basic_info_resp();
            $bincodec = new \DrSlump\Protobuf\Codec\Binary();
            $req = $bincodec->encode($sendobj);
            $ret = php_wns_ipc_to_self(\wns\module_id_e::REALINFO_SRV, 0,
                \wns\webui_msgid_monitor_info_e::BRANCH_WAC_BASIC_STAT_INFO_REQ, $req,
                \wns\webui_msgid_monitor_info_e::BRANCH_WAC_BASIC_STAT_INFO_RESP, 3);
            $obj = $bincodec->decode($replyobj, $ret['buf']);
            if($obj === null) {
                bug(__('获取数据失败，请检查服务是否已运行'));
            }

            $result = $obj->getBranchBasicInfo();
            $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
            foreach ($result as $key => $val) {
                $val = $arrcodec->encode($val); //转成数组
                $realbranchinfo[$val['account_id']] = $val;
            }
            $auth_center_map = array_flip($this->sc_disaster_group_model->getCenterAuthBranch());
        }
        foreach($this->_recordset as $key => $record)
        {
            if($onlyRealBranch){
                if(!isset($realbranchinfo[$record['id']])){
                    unset($this->_recordset[$key]);
                    continue;
                }
            }
            unset($this->_recordset[$key]['pwd']); //密码不返回给列表
            $this->_recordset[$key]['is_center_auth_n'] = false;
            if(isset($realbranchinfo[$record['id']]))
            {
                if($realbranchinfo[$record['id']]['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE &&
                    isset($auth_center_map[$record['id']]))
                {
                    $realbranchinfo[$record['id']]['auth_style'] = \wns\branch_auth_style::CENTER_AUTH;
                    $this->_recordset[$key]['is_center_auth_n'] = $this->sc_disaster_group_model->isAuthCenterNBranchByBranchId($record['id']);
                }
                $this->_recordset[$key] =  $this->_recordset[$key] + $realbranchinfo[$record['id']];
            }  
            if($record['id'] === CENTER_ID)
                $this->_local_wac_record = $this->_recordset[$key];
        }
        return $this->_recordset;
    }

    /**
     * 获取控制器状态页面图表过滤的ipc请求对象
     * @return \webui_msg\branch_wac_basic_info_req
     */
    protected function getExpertSearchSendObj()
    {
        $sendobj = new \webui_msg\branch_wac_basic_info_req();
        $sendobj->setIsAll(true);
        if(isset($this->_args['expert_search']['analysis_type'])){//图表模块类型
            $this->load->model('sys_configure/runstat/sc_sys_runstat_model');
            $type = $this->sc_sys_runstat_model->wacAnalysisTypeReal($this->_args['expert_search']['analysis_type']);
            $sendobj->setAnalysisType($type);
        }
        if(isset($this->_args['expert_search']['analysis_part'])){//图表模块区间
            $sendobj->setAnalysisPart((int)$this->_args['expert_search']['analysis_part']);
        }
        return $sendobj;
    }
    
    
    
    /**
     * 获取在线的集中管理列表信息，关联数组，下标为网点id
     * @param bool $more 为true时返回更多字段
     * @return array
     */
    public function get_online_mgmt_branch_list_assoc($more=false)
    {
        static $ret = null;
        if(!isset($ret))
        {
            $ret = [];
            $list = $this->get_online_mgmt_branch_list($more);
            foreach($list as $val)
            {
                $ret[$val['id']] = $val;
            }
        }
        return $ret;
    }

    /**
     * 获取在线的集中管理列表信息
     * @param bool $more 为true时返回更多字段
     * @return array
     */
    public function get_online_mgmt_branch_list($more=false) {
        $this->get_real_branch_list();
        $ret = array();

        if($more)
        {
            //$centrer = array('id' => 0, 'name' => __('中心控制器'), 'auth_style' => -1,); //先包含中心端
            foreach($this->_recordset as $key => $record)
            {
                if(isset($record['mode']) && $record['monitor_stat']
                    && $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
                {
                    $auth_style = isset($record['auth_style']) ?
                    \wns\branch_auth_style::CENTER_AUTH : \wns\branch_auth_style::DISTBT_AUTH;
                    $ret[] = array('id' => $record['id'], 'name' => $record['name'], 'auth_style' => $auth_style);
                }
            }
        }
        else
        {
            //$centrer = array('id' => 0, 'name' => __('中心控制器')); //先包含中心端
            foreach($this->_recordset as $key => $record)
            {
                if(isset($record['mode']) && $record['monitor_stat']
                    && $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
                {
                    $ret[] = array('id' => $record['id'], 'name' => $record['name'],);
                }
            }
        }
        $ret = $this->check_branch_data($ret, 'id', 'desc');
   //     if($this->check_center_right())
   //         $ret['tree'] = array_merge([$centrer],$ret['tree']);
        return $ret['tree'];
    }

    /**
     * 获取在线的集中管理列表信息
     */
    public function get_online_mgmt_branch_map() {
        $this->get_real_branch_list();
//        $ret[0] = true; //中心控制器
        foreach($this->_recordset as $key => $record)
        {
            if(isset($record['mode']) && $record['monitor_stat']
                && $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
            {
                $ret[$record['id']] = true;
            }
        }
        return $ret;
    }

    /**
     * 获取集中管理/维护列表信息
     * @param bool $more 为true时返回更多字段
     * @param bool $no_cloud_branch 是否显示云网点
     */
    public function get_mgmt_branch_list($more=false, $no_cloud_branch = false) {
        $this->get_real_branch_list();
        $ret = array();
        if($more)
        {
         //   $ret[] = array('id' => 0, 'name' => __('本地控制器'), 'auth_style' => -1); //先包含中心端
            foreach($this->_recordset as $key => $record)
            {
                if($no_cloud_branch)
                {
                    if(isset($record['platform']) && $record['platform'] == \wns\branch_platform_e::CLOUD)
                        continue;
                }
                if(isset($record['mode']) &&
                    ($record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                        $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
                {
                    $auth_style = isset($record['auth_style']) ?
                    \wns\branch_auth_style::CENTER_AUTH : \wns\branch_auth_style::DISTBT_AUTH;
                    $ret[$record['id']] = array(
                        'id' => $record['id'],
                        'name' => $record['name'],
                        'auth_style' => $auth_style,
                        'platform' => $record['platform'],
                    );
                }
            }
        }
        else
        {
        //    $ret[] = array('id' => 0, 'name' => __('本地控制器')); //先包含中心端
            foreach($this->_recordset as $key => $record)
            {
                if($no_cloud_branch)
                {
                    if(isset($record['platform']) && $record['platform'] == \wns\branch_platform_e::CLOUD)
                        continue;
                }
                if(isset($record['mode']) &&
                    ($record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                        $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
                {
                    $ret[$record['id']] = array(
                        'id' => $record['id'], 
                        'name' => $record['name'],
                        'platform' => $record['platform'],
                    );
                }
            }
        }
        return $ret;
    }

    public function check_is_mgmt_branch($ids)
    {
        static $mgmt_branch = null;
        static $map = array();
        if(is_null($mgmt_branch))
        {
            $mgmt_branch = $this->get_mgmt_branch_list();
            $map = array();
            foreach($this->_recordset as $key=>$val)
            {
                $map[$val['id']] = $val['name'];
            }
        }
        $ids = is_array($ids)?$ids:array($ids);
        foreach($ids as $id)
        {
            if($id == CENTER_ID)
                continue;
            if(isset($mgmt_branch[$id]))
                continue;
            bug(__('分支不是管理/维护模式',$map[$id]));
        }
        return true;
    }

    /**
     * 根据id判断分支是否是维护模式
     * @param $id
     * @return bool
     */
    public function check_is_maintenance_branch($id)
    {
        static $branch_infos = null;
        if (is_null($branch_infos)) {
            $this->get_real_branch_list();
            foreach ($this->_recordset as $key => $val) {
                if(isset($val['mode']) && $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE)
                    $branch_infos[$val['id']] = $val;
                }
            }
            $id = intval($id);
            if(isset($branch_infos[$id]))
            {
                return true;
            }
            return false;
        }


    /**
     * 根据id判断分支是否是监控模式
     * @param $id
     * @return bool
     */
    public function check_is_monitor_branch($id)
    {
        static $branch_infos = null;
        if (is_null($branch_infos)) {
            $this->get_real_branch_list();
            foreach ($this->_recordset as $key => $val) {
                if(isset($val['mode']) && $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE)
                    $branch_infos[$val['id']] = $val;
                }
            }
            $id = intval($id);
            if(isset($branch_infos[$id]))
            {
                return true;
            }
            return false;
        }

    /**
     * 过滤出有权限的分支list
     * @param $list
     * @param string $field
     * @return array
     */
    public function filter_branch_list($list,$field='id')
    {
        $list = array_usort($list, 'name', 'asc', 'pinyin_sort_cmp');
        $list = sort_apgroup($list, 'id');
        if (is_super_role())
        {
            return $list;
        }
        $right_ids = $this->get_right_branch_data();
        if($right_ids['all_branch']){
            return $list;
        }
        foreach($list as $key => $row)
        {
            if(isset($right_ids['data'][$row[$field]]))
            {
                continue;
            }
            unset($list[$key]);
        }
        if(empty($list))
            $list = array();
        else
            $list = array_values($list);

        return $list;
    }

    /**
     * 获取接入点管理页面
     */
    public function get_show_branch_list() {
        $this->get_real_branch_list();
        $ret = array();
   //     $ret[] = array('id' => 0, 'name' => __('中心控制器'),'group_id'=>1); //先包含中心端
        $addbranch = array(); //追加在后面显示：曾经加入过集中管理而现在切换成了集中监控 或者 独立WAC的分支
        foreach($this->_recordset as $key => $record)
        {
            if(isset($this->_args['allHasSn']) && !$this->_args['allHasSn'])   //如果有些没有sn码，过滤掉云网点
            {
                if(2 == $record['platform'])
                    continue;
            }
            if(isset($record['mode']) && $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
                {
                    $ret[] = array('id' => $record['id'], 'name' => $record['name'],'group_id'=>$record['group_id']);
                }
                else
                {
                    $sn_file = self::BRANCH_FOLDER.$record['id'].'/wns_cfg_sn_info.xml';
                if(file_exists($sn_file)) //存在sn_info配置，代表曾经加入过集中管理
                {
                    $addbranch[] = array('id' => $record['id'], 'name' => $record['name'],'group_id'=>$record['group_id']);
                }
            }
        }
        if(!empty($addbranch))
        {
            $ret = array_merge($ret, $addbranch);
        }
        return $ret;
    }

    /*
    获取集中认证的分支
    */
    public function get_central_auth_branch_list(){
        $this->get_real_branch_list();
        $ret = array();
//        $ret[] = array('id' => 0, 'name' => __('中心控制器'),'group_id'=>1); //先包含中心端
        foreach($this->_recordset as $key => $record)
        {
            if(isset($record['mode']) && $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
                {
                    if(isset($record['auth_style']) && $record['auth_style'] ==1){
                        $ret[] = array('id' => $record['id'], 'name' => $record['name'],'group_id'=>$record['group_id']);
                    }
                }
            }
            return $ret;
        }
    /**
     * 通过分支所在分组，获取可配置的分支
     * @return array
     */
    public function listConfigBranchByPID()
    {
        $this->_recordset = $this->get_show_branch_list();
        $this->_filter();
        $arr = array_paging($this->_recordset, $this->_args['start'], $this->_args['limit']); //分页
        return $arr;
    }

    /**
     * 通过分支所在分组，获取集中认证的分支，用于漫游域控制器
     * @return array
     */
    public function listCentralAuthBranchByPID()
    {
       $this->_recordset = $this->get_central_auth_branch_list();
       $this->_filter();
         $arr = array_paging($this->_recordset, $this->_args['start'], $this->_args['limit']); //分页
         return $arr;
     }


    /**
     * 获取列表信息
     */
    public function listbranch() {
        //非网点不返回信息
        if(false == strstr($this->_wac_role, "branch")) {
            return ['data'=>[]];
        }
        $replyobj = new \webui_msg\branch_stat_info_resp();
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::BRANCH_INFO_C, '',
            \wns\webui_msgid_sc_e::BRANCH_INFO_R, 3);
        if($ret === null || $ret === -2)
        {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        $retdata = $this->_conv_msgObj_to_array($obj);
        $branch_version = exec('cat /app/appversion | head -n1');
        $retdata['version'] = $branch_version;
//        $retdata['center_addr'] = $this->_sc_info['join_sc']['center_addr']; //后台返回这个字段
        $result = array('data' => $this->get_ui_branch_status($retdata));
        return $result;
    }

    /**
     * 获取WAC的SC信息
     */
    public function list_sc_info()
    {
        $ret = $this->_sc_info;
        if(isset($ret['join_sc']))
        {
            $ret['join_sc']['branch_mode'] = $this->branch_mode2ui($ret['join_sc']['branch_mode'],$ret['join_sc']['auth_style']);
        }
        $ret['wac_mode'] = $this->wac_role2ui( $ret['wac_mode']);
        return $ret;
    }

    /**
     * 控制器角色UI显示转换
     */
    protected function wac_role2ui($role)
    {
        $uirole = "";
        switch($role)
        {
            case \wns\wac_role_e::INDEPENDENT_E :
            $uimode = INDEPENDENT;
            break;
            case \wns\wac_role_e::CENTER_E :
            $uimode = CENTER;
            break;
            case \wns\wac_role_e::BRANCH_E :
            $uimode = BRANCH;
            break;
            default:
            break;
        }
        return $uimode;
    }
    /**
     * 分支模式UI显示转换
     */
    public function branch_mode2ui($mode,$auth_style=\wns\branch_auth_style::DISTBT_AUTH)
    {
        $uimode = "";
        switch($mode)
        {
            case \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE :
            $uimode = 'monitor';
            break;
            case \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE :
            $uimode = 'mgmt';
            if($auth_style === \wns\branch_auth_style::CENTER_AUTH)
                $uimode = 'centerauth';
                break;
                case \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE :
                $uimode = 'mainten';
                break;
                default:
                break;
            }
            return $uimode;
        }

        protected function _assert_branch_status($status)
        {
            switch($status)
            {
                case \wns\branch_status_type_e::WEB_ONLINE :
                $msg = __("分支在线");
                break;
                case \wns\branch_status_type_e::WEB_OFFLINE :
                $msg = __("分支离线");
                break;
                case \wns\branch_status_type_e::WEB_NONE_ACCOUNT :
                $msg = __("分支不存在");
                break;
                case \wns\branch_status_type_e::WEB_PASSWORD_ERR :
                $msg = __("分支密码错误");

                break;
                case \wns\branch_status_type_e::WEB_ACCOUNT_LOGIN :
                $msg = __("分支使用的账号已登录，请使用其他账号接入");
                break;
                case \wns\branch_status_type_e::WEB_DIFF_VERSION :
                $msg = __("分支与中心端版本不一致");
                break;
                case \wns\branch_status_type_e::WEB_EXCEED_LIMIT :
                $msg = __("分支个数超出限制");
                break;
                case \wns\branch_status_type_e::WEB_NETWORK_OFF :
                $msg = __("与中心端网络不通");
                break;
                case \wns\branch_status_type_e::WEB_CONNECT_FAIL :
                $msg = __("网络正常，分支连接中心端失败");
                break;
                case \wns\branch_status_type_e::WEB_KB_PACKAGE :
                $msg = __("与中心端kb包不一致，不允许加入集中管理");
                break;
                default :
                $msg = "";
                break;
            }
            return $msg;
        }
    /**
     * 分支状态UI显示转换
     */
    protected function get_ui_branch_status($retdata) {
        if(isset($retdata['auth_style']))
            $retdata['mode'] = $this->branch_mode2ui($retdata['mode'],$retdata['auth_style']);
        else
            $retdata['mode'] = $this->branch_mode2ui($retdata['mode']);
        $retdata['msg'] = $this->_assert_branch_status($retdata['status']);
        if($retdata['status'] === \wns\branch_status_type_e::WEB_ONLINE)
            $retdata['status'] = true;
            else
                $retdata['status'] = false;

            $retdata['last_conn_time'] = date("Y-m-d H:i:s",$retdata['last_conn_time']);
            return $retdata;
        }

    /**
     * 返回记录总数
     */
    public function gettotalcnt() {
        return $this->_recordset_total;
    }

    /**
     * 详细记录
     *
     */
    public function detail() {
        //供子类定制
        foreach ($this->_recordset as $key => $val) {
            if (isset($this->_args['data']['id']) && $val['id'] === $this->_args['data']['id']) {
                $val['pwd'] = $this->pwdenc_model->pwd_dencypt($val['pwd']);
                if(isset($val['group_id']))
                {
                    $this->load->model('sys_configure/central_monitor/central_area_model');
                    $val['path']['id'] = $val['group_id'];
                    $val['path']['text'] =
                    $this->central_area_model->get_path_by_grpid($val['group_id']);
                }
                if($val['id'] != CENTER_ID)
                {
                    if($val['is_slave'] && isset($val['slave_model'])){
                        $model = isset($val['slave_model'])?$val['slave_model']:null;
                        $this->log->add('debug', 'choose slave model');
                    }else{
                        $model = isset($val['model'])?$val['model']:null;
                        $this->log->add('debug', 'choose master model');
                    }
                }

                if(isset($model))
                {
                    $value = $this->get_model_ui_show($model);
                    $val['model'] = array(
                        'text' => $model,
                        'value' => is_null($value) ? __('自动匹配') : $value,
                    );
                }
                return $val;
            }
        }
        bug(__('record_unexist'));
    }

    /**
     * 排序
     *
     */
    protected function _sort() {

        if(!isset($this->_args['sort']) || $this->_args['sort'] !== 'status') {
            $this->_args['sort'] = 'name';
        }
        if(!isset($this->_args['dir']))
            $this->_args['dir'] = 'desc';
        $this->_recordset = array_usort($this->_recordset, $this->_args['sort'], $this->_args['dir'], 'pinyin_sort_cmp');
        if(!isCloudSc())
        {
            foreach ($this->_recordset as $key => $val)
            {
                if($val['id'] === CENTER_ID)
                {
                    unset($this->_recordset[$key]);
					//将本地控制器放在首行
                    array_unshift($this->_recordset, $this->_local_wac_record);
                    break;
                }
            }
            
            
        }
    }

    /**
     * 替换成前端识别的数据
     *
     * @return      array
     */
    protected function _replace() {
        foreach($this->_recordset as &$data)
        {
            if(!isset($data['monitor_stat']))
            {
                $data['status'] = -1;
            }else{
                $data['status'] = $data['monitor_stat'];
            }

            if(!isset($data['platform']))
            {
                $data['platform'] = \wns\branch_platform_e::ENTITY;
            }
        }
    }

    /**
     * 过滤$this->_recordset
     *
     */
    protected function _filter() {
        //供子类定制
        $this->load->model('sys_configure/central_monitor/central_area_model');
        if(isset($this->_args['filter']['group_id']))
        {
            $this->_args['group_id'] = $this->_args['filter']['group_id'];
        }
        if(isset($this->_args['group_id']) && $this->_args['group_id'] !== '')
        {
            $filter_grps = $branch = array();
            $this->central_area_model->get_right_grp(
                array(intval($this->_args['group_id'])), $filter_grps, $branch);
        }

        if(isset($this->_args['filter']['beg']) && $this->_args['filter']['end'])
        {
            $begintime = strtotime($this->_args['filter']['beg'].' 00:00:00');
            $endtime = strtotime($this->_args['filter']['end'].' 23:59:59');
        }
        foreach($this->_recordset as $key => $val)
        {
            if(isset($filter_grps) && !isset($filter_grps[$val['group_id']]))
            {
                unset($this->_recordset[$key]);
            }
            if(isset($this->_args['filter']['status']) && $this->_args['filter']['status'] != -2) //-2代表所有
            {
                if(intval($this->_args['filter']['status']) !== $val['status'])
                {
                    unset($this->_recordset[$key]);
                }
            }
            if(isset($this->_args['filter']['mode']) && $this->_args['filter']['mode'] != -1) // -1代表所有
            {
                if(!isset($val['mode']))
                {
                    unset($this->_recordset[$key]);
                }
                else{
                    $filter_mode = intval($this->_args['filter']['mode']);
                    $mode = $val['mode'];
                    if(in_array($filter_mode, [self::JS_FILTER_BRANCH_AUTH_TYPE_CENTER,self::JS_FILTER_BRANCH_AUTH_TYPE_DISTBT]) && $mode === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
                        {
                        $mode = (isset($val['auth_style']) && $val['auth_style']===\wns\branch_auth_style::CENTER_AUTH)?self::JS_FILTER_BRANCH_AUTH_TYPE_CENTER:self::JS_FILTER_BRANCH_AUTH_TYPE_DISTBT; //前端mode=4代表集中认证，5代表分布式认证
                    }
                    if($filter_mode !== $mode)
                    {
                        unset($this->_recordset[$key]);
                    }
                }
            }
            if(isset($this->_args['filter']['unactive']) && $this->_args['filter']['unactive'] != -1) // -1代表所有
            {
                if(!isset($val['unactive_ap_cnt']) || (bool)$this->_args['filter']['unactive'] !== (bool)$val['unactive_ap_cnt'])
                {
                    unset($this->_recordset[$key]);
                }
            }
            if(isset($this->_args['filter']['offline']) && $this->_args['filter']['offline'] != -1) // -1代表所有
            {
                if(!isset($val['offline_ap_cnt']) || (bool)$this->_args['filter']['offline'] !== (bool)$val['offline_ap_cnt'])
                {
                    unset($this->_recordset[$key]);
                }
            }
            if(isset($begintime))
            {
                if(!isset($val['last_update_time']) ||
                    $val['last_update_time'] < $begintime || $val['last_update_time'] > $endtime )
                {
                    unset($this->_recordset[$key]);
                }
            }
        }
        $this->_recordset = array_values($this->_recordset);
        if(isset($this->_args['filter']['name']))
        {
            array_query($this->_recordset, array('name'), $this->_args['filter']['name']);
        }
        elseif(isset($this->_args['keyword']))
        {
            array_query($this->_recordset, array('name'), $this->_args['keyword']);
        }
        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");
        $this->_recordset = $this->filter_branch_list($this->_recordset);
        $this->_recordset_total = count($this->_recordset);

    }

    /**
     * 删除，最好支持批量删除
     *
     * @param       $write      bool        是否写入磁盘
     */

    public function delete($write = true) {
        //备份配置
        $this->bak_branchs = $this->_recordset;
        //供子类定制
        $need_write = false;
        $delete_ids = array();
        $sucarr = array();
        $failarr = array();
        //删除本地控制器记录
        if(!isCloudSc())
        {
            $this->delete_local_wac_record();
        }
        if(isset($this->_args['selectall']) && $this->_args['selectall'])
        {
            $bak_data = $this->_recordset;
            $this->_filter();
            $this->_args['data'] = $this->_recordset;
            $this->_recordset = $bak_data;
        }
        foreach ($this->_args['data'] as $key => $val) {
            $id = intval($val['id']);
            $record = array('id' => $id);
            if (!$this->is_id_exist($record, $index)) {
                continue;
            }

            if($id === CENTER_ID)
                continue;

            if(!$write) //更新记录时，暂时删除记录、不写入磁盘，不需要检查引用关系和写日志
            {
                unset($this->_recordset[$index]);
                return true;
            }
            if (!is_null($index)) {
                if(!isset($val['platform']) || intval($val['platform'])  === \wns\branch_platform_e::ENTITY)
                    {
                        unset($this->_recordset[$index]);
                        $sucarr[] = $val['account'];
                        $delete_ids[] = $val['id'];
                        $need_write = true;
                    }
                    else
                    {
                        $failarr[] = $val['name'];
                    }
                } 

            }
            if(!empty($failarr))
            {
                $limit = config_item('logobj_limit');
                $string = and_so_on_limit($failarr, $limit);
                bug(__('云控制器分支{0}不允许删除', $string));
            }

        //检查引用关系
            $this->_check_reference($delete_ids,$this->_args['data']);

            if ($need_write && $write)
            {
                $rs = parent::delete($write);
            }

            $data = array(
                'succList' => $sucarr,
//            'errorList' => $citearr,
            );
            $this->deleteAfter($delete_ids);
            if($this->_action !== __FUNCTION__)
                return true;
            if(!empty($sucarr)) {
                $limit = config_item('logobj_limit');
                $string = and_so_on_limit($sucarr, $limit);
                $msg = __('删除分支账号').$string;
                parent::addLog('controller_cluster',$msg,true);
            }
            return $data;
        }


    /**
     * 检查引用关系
     * @param $delete_ids
     * @param $args
     * @return bool
     * @throws Exception
     */
    protected function _check_reference($delete_ids, $args)
    {
        $reference_branchs=$this->reference_check($delete_ids,$args);
        if(!empty($reference_branchs)){
            bug(__('分支{0}在功能配置->接入点策略->无线漫游域->漫游控制器中被引用', and_so_on($reference_branchs)));
            return  false;
        }

        //被认证托管组引用
        $this->load->model('sys_configure/central_monitor/sc_disaster_group_model');
        foreach ($delete_ids as $branch_id) {
            $disaster_group = $this->sc_disaster_group_model->get_group_info_by_branch_id($branch_id);
            if(isset($disaster_group['name'])) {
                $branch_name = $this->get_account_by_id($branch_id, $args);
                bug(__('分支 {0} 已被认证托管组 {1} 引用', $branch_name, $disaster_group['name']));
            }
        }

        //被升级任务引用，且分支正在升级
        $this->load->model('system_maintenance/upgrade/sc_upg_detail_model');
        foreach ($delete_ids as $branch_id) {
            if($this->sc_upg_detail_model->is_branch_upgrading($branch_id)) {
                $branch_name = $this->get_account_by_id($branch_id, $args);
                bug(__('分支 {0} 正在升级，不能进行删除操作', $branch_name));
            }
        }
        return true;
    }


    protected function deleteAfter($delete_ids)
    {
        if(empty($delete_ids))
            return true;
        foreach($delete_ids as $branch_id)
        {
            //分支删除时，需要删除该分支配置的文件夹
            $branch_dir = self::BRANCH_FOLDER . $branch_id;
            if (is_dir($branch_dir))
            {
                $this->exec("rm -rf ".$branch_dir, $output, $code);
            }
            $branch_mirror_dir = self::BRANCH_MIRROR_FOLDER . $branch_id;
            if (is_dir($branch_mirror_dir))
            {
                $this->exec("rm -rf ".$branch_mirror_dir, $output, $code);
            }
        }
        //删除分支账号时删除引用文件
        exec('rm -f /wns/etc/config/wac/*.json');
        //删除掉分支的AP组、AP配置
        $this->load->model("wireless_configure/wireless_ap/wl_ap_model");
        $this->wl_ap_model->delete_record_by_branchid($delete_ids);
        if(!empty($delete_ids))
        {
            $this->load->model('runstat_configure/spotted_map_model');
            $this->spotted_map_model->delete_entity_by_branch($delete_ids);
        }
        return true;
    }

    //删除非本机的ap信息
    public function delete_non_native_ap_info()
    {
        //删除引用文件
        exec('rm -f /wns/etc/config/wac/*.json');
        //删除非本机的AP组、AP配置
        $this->load->model("wireless_configure/wireless_ap/wl_ap_model");
        $this->wl_ap_model->delete_non_native_record();
        $this->load->model('runstat_configure/spotted_map_model');
        $this->spotted_map_model->delete_non_native_entity();
    }

    public function deleteCloudBranch()
    {
        //备份配置
        $this->bak_branchs = $this->_recordset;
        $delete_ids = $sucarr = [];
        foreach ($this->_args['data'] as $key => $val) {
            if (!$this->is_cloud_id_exist($val, $index)) {
                continue;
            }
            if (!is_null($index)) {
                $sucarr[] = $this->_recordset[$index]['account'];
                $delete_ids[] = $this->_recordset[$index]['id'];
                unset($this->_recordset[$index]);
            }
        }
        $data = array(
            'succList' => $sucarr,
        );
        if(empty($delete_ids))
            return $data;
        $rs = parent::delete(true);
        $this->deleteAfter($delete_ids);
        if($this->_action !== __FUNCTION__)
            return true;
        if(!empty($sucarr)) {
            $limit = config_item('logobj_limit');
            $string = and_so_on_limit($sucarr, $limit);
            $msg = __('删除云分支账号').$string;
            parent::addLog('controller_cluster',$msg,true);
        }
        return $data;
    }

    /**
     * 查看同步日志
     */
    public function get_sc_synclog()
    {
        if($this->_wac_role === CENTER)
        {
            if(isset($this->_args['data']['id']))
                $log_pre = '['. $this->_args['data']['id']. ']';
            else
                return array(__('无日志'));
        }
        else
            $log_pre = '[0]';

        $arr = array();
        if(!$fp = fopen(self::SC_SYNCLOG, 'r'))
            {
                return __('无日志');
            }
            $pos=-2;
            $eof="";
            $n = self::SC_SYNCLOG_CNT;
            while($n > 0)
            {
                while($eof != "\n")
                {
                    if(!fseek($fp, $pos, SEEK_END))
                    {
                        $eof=fgetc($fp);
                        $pos--;
                    }
                    else
                    {
                        break;
                    }
                }
                $str_tmp = fgets($fp);
                if(!$str_tmp)
                {
                    break;
                }
                if(stripos($str_tmp, $log_pre) !== false)
                {
                $arr[] = substr($str_tmp, strlen($log_pre));//$str_tmp去除一下前缀
                //$arr[] = $str_tmp;
                $n--;
            }
            $eof="";
        }
        if(empty($arr))
        {
            return array(__('无日志'));
        }
        return $arr;
    }

    /**
     * 提取主键
     */
    protected function _get_id($arr) {
    }

    /**
     * 修改
     *
     * @param       $write      bool        是否写入磁盘
     */
    public function update($write = true) {
        //供子类定制
        $record = array();
        $record['id'] = intval($this->_args['data']['id']);
        if (!$this->is_id_exist($record, $index))
        {
            bug(__('record_unexist'));
        }
        $this->_old_index = $index;
        $this->_old_record = $record_bak = $this->_recordset[$index];
        if('export_data' !== $this->_action)
        {
            if(isset($record_bak['model']) && $record_bak['model'] !== $this->_args['data']['model']['text'] ||
            !isset($record_bak['model']) && !empty($this->_args['data']['model']['text']))
            {
                $records_bak = $this->_recordset;
                if($this->is_branch_online($record['id']))
                {
                    bug(__('当前分支处于在线状态，不允许修改设备型号'));
                }
                $this->_recordset = $records_bak;
                $this->_inter_update_branch[] = array(
                    'id' => $record_bak['id'],
                    'model' => $this->_args['data']['model']['text'],
                );
            }
        }
        $args_bak = $this->_args;
        $this->_args = array('data' => array($this->_args['data']));
        if ($this->delete(false))
        {
            $this->_args = $args_bak;
            try
            {
                $rs = $this->create($write);
                if ($this->log->has_error() || !$rs) //重建失败保留原来的记录
                {
                    $this->_recordset[$index] = $record_bak;
                }
            }
            catch (Exception $e)
            {
                $this->_recordset[$index] = $record_bak;
                throw $e;
            }
            if (__FUNCTION__ === $this->_action)
            {
                if ($rs)
                {
                    parent::addLog('controller_cluster',__('编辑分支账号 %s',$this->_old_record['account']),true);
                }
                else
                {
                    parent::addLog('controller_cluster',__('编辑分支账号 %s',$this->_old_record['account']),false);
                }
            }
            return $rs;
        }
        else
        {
            bug(__('unable_delete_record'));
        }
    }

    /**
     * 判断记录是否存在
     *
     * @param       $record     mixed       记录
     * @param       $index      mixed       冲突记录的索引
     * @return                  bool
     */
    public function is_name_exist($record, &$index = null) {
        //供子类定制
        foreach ($this->_recordset as $key => $val) {
            if ($val['name'] === $record['name']) {
                $index = $key;
                return true;
            }
        }
        return false;
    }

    /**
     * 判断账号是否存在
     *
     * @param       $record     mixed       记录
     * @param       $index      mixed       冲突记录的索引
     * @return                  bool
     */
    public function is_account_exist($record, &$index = null) {
        //供子类定制
        foreach ($this->_recordset as $key => $val) {
            if ($val['account'] === $record['account']) {
                $index = $key;
                return true;
            }
        }
        return false;
    }

    public function is_id_exist($record, &$index = null) {

/*      if($this->_wac_role === CENTER && $record['id'] === CENTER_ID){
            return true;
        }*/
        foreach ($this->_recordset as $key => $val) {
            if ($val['id'] === $record['id']) {
                $index = $key;
                return true;
            }
        }
        return false;
    }

    public function is_cloud_id_exist($cid, &$index = null)
    {
        foreach ($this->_recordset as $key => $val) {
            if(isset($val['platform']) && $val['platform'] === \wns\branch_platform_e::CLOUD){
                if ($val['cloud_config']['docker_id'] === $cid) {
                    $index = $key;
                    return true;
                }
            }

        }
        return false;
    }

    /*
     引用检查，删除分支和切换分支模式时调用,返回被应用分支名称的数组
    */
     public function reference_check($branch_ids,$all_ids){
         //判断删除的分支id是否被引用
       $ref_accounts = array();
       $this->load->model('wireless_configure/roam_domain/roam_wac_model');
       foreach($branch_ids as $branch_id){
        if($this->roam_wac_model->isHasReferenced($branch_id)){
            $ref_accounts[]=$this->get_account_by_id($branch_id,$all_ids);
        }
    }
    return $ref_accounts;
}

    /*
     通过分支id获取分支名称
    */
     public function get_account_by_id($branch_id,$all_ids) {
        $id=intval($branch_id);
        foreach ($all_ids as $val) {
            if (intval($val['id']) == $id) {
                return $val['name'];
            }
        }
        return null;
    }
    protected function _read_branch_info()
    {
        $rs = array_from_xml_file($this->_branch_conf, 'wns.branch_info');
        if (is_null($rs) || -1 === $rs) {
            bug(__('unexpected_config'));
        }
        $this->_branch_record = $rs;
    }

    /**
     * 读取，从配置文件读取原始数据到$this->_recordset
     */
    protected function _read() {
        //供子类定制
        $msg = new \wns\sc_info_t();
        if (!$this->_read_protobuf_from_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf)) {
            /*if (!is_empty($rs))*/ {
                bug(__('unexpected_config'));
            }
        }

        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $this->_sc_info = $arrcodec->encode($msg); //转成数组
        $this->_sc_info_msg = $msg;
        $wac_role = $this->_sc_info['wac_mode'];
        if($wac_role === \wns\wac_role_e::CENTER_E) //中心端支持查看分支状态列表
        {

            $this->_read_branchs();
            if(!isCloudPlatform())
            {
                $this->_read_local_wac();
            }
            $this->_wac_role = CENTER;
        }
        elseif($wac_role === \wns\wac_role_e::BRANCH_E)
            {
                if($this->_sc_info['join_sc']['branch_mode']=== \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE)
                    {
                        $this->_wac_role = MONITOR_BRANCH;
                    }
                    else
            {//维护模式是特殊的管理模式
                if($this->_sc_info['join_sc']['branch_mode']=== \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
                    {
                        $this->_read_branch_info();
                        if($this->_branch_record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE)
                    {//维护模式
                        $this->_mgmt_child_role = MGMT_MAINTENANCE;
                    }
                    else if(isset($this->_branch_record['auth_style']) &&
                        $this->_branch_record['auth_style'] === \wns\branch_auth_style::CENTER_AUTH)
                    {
                        $this->_mgmt_child_role = MGMT_CENTERAUTH;
                    }
                    else
                    {
                        $this->_mgmt_child_role = MGMT_DISTRIBUTEAUTH;
                    }
                }
                else
                {
                    $this->_mgmt_child_role = MGMT_MAINTENANCE;
                }

                $this->_wac_role = MGMT_BRANCH;
            }

        }
        else
        {
            $this->_wac_role = INDEPENDENT;
        }
    }

    /**
     * 获取分支列表
     */
    public function get_branch_list()
    {
        $ret = array();
        if(!is_center_wac())
        {
            return $ret;
        }
        foreach($this->_recordset as $val)
        {
            $ret[$val['id']] = $val;
        }
   //     $ret[0] = array('name' => __('本地控制器'),'id'=>CENTER_ID);
        return $ret;
    }

    protected function scBakBranchRecord()
    {
        if(!empty($this->bak_branchs)){
            $ret = [];
            foreach($this->_recordset as $val)
            {
                $ret[$val['id']] = $val;
            }
            return $ret;
        }else{
            return $this->get_branch_list();
        }
    }

    /**
     * 获取真实的ID给云平台
     * 实体机为ID， 云分支为docker_id
     * @param array $branchIds      带获取的分支
     * @return array
     */
    public function scGetIdToCloud(array $branchIds)
    {
        //网点删除时区备份的记录
        $branchs = $this->scBakBranchRecord();
        $data = [];
        foreach ($branchIds as $bid){
            if(isset($branchs[$bid])){
                $data[] = ($branchs[$bid]['platform'] === \wns\branch_platform_e::CLOUD) ?
                $branchs[$bid]['cloud_config']['docker_id'] : $branchs[$bid]['id'];
            }
        }
        return $data;
    }

    /**
     * 获取所有分支的树结构
     * @return array
     */
    public function get_branch_tree()
    {
        $branchs = $this->get_branch_list();
        $tree = array();
        foreach($branchs as $branch)
        {
            $node = array();
            $node['id'] = $branch['id'];
            $node['branch_id'] = $branch['id'];
            $node['name'] = $branch['name'];
            $node['type'] = 'branch';
            $node['leaf'] = true;
            $node['checked'] = false;
            $node['children'] = array();
            if($node['id'] === 0)
            {
                $node['deletable'] = false;
            }
            $tree[] = $node;
        }
        $tree = $this->check_branch_data($tree);
        return $tree;
    }

    /**
     * 读取，从配置文件读取原始数据到$this->_recordset
     */
    protected function _read_branchs()
    {
        $branch_cfg = array_from_xml_file($this->_conf, 'wns.BranchTable');
        if (is_null($branch_cfg) || -1 === $branch_cfg) {
            bug(__('unexpected_config'));
        }

        $rs = $branch_cfg['branch_list'];
        $this->_max_id = $branch_cfg['maxid'];
        $branch_status_conf = $this->readCenterBranchListConf();
        foreach ($rs as $key => $val) {
            $this->_read_callback($rs[$key]);
            if(!isset($rs[$key]['group_id']))
                $rs[$key]['group_id'] = 0;
            $rs[$key]['is_slave'] = false;
            if(isset($branch_status_conf[$val['id']]) && isset($branch_status_conf[$val['id']]['is_slave']))
            {
                $rs[$key]['is_slave'] = $branch_status_conf[$val['id']]['is_slave'];
            }
            $this->_used_idset[$rs[$key]['id']] = $rs[$key]['id']; //已经使用了的id集合
        }
        $this->_recordset = $rs;
        $this->_recordset_total = count($this->_recordset);
    }

    /**
     * 读取，从配置文件读取原始数据到$this->_recordset
     */
    protected function _read_local_wac()
    {
        $rs = array_from_xml_file($this->_local_wac_conf, 'wns.Branch');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!isset($rs['net_manage_type']))
            $rs['net_manage_type'] = \wns\net_manage_e::BRANCH_MANAGE;
        if(!isset($rs['platform']))
            $rs['platform'] = \wns\branch_platform_e::ENTITY; 
        if(in_array($rs['name'], ['本地控制器', 'Local Controller']))
            $rs['name'] = __($rs['name']);
        $this->_local_wac_record = $rs;
        array_unshift($this->_recordset, $rs);
        $this->_recordset_total = count($this->_recordset);
    }

    /**
     * 将$this->_recordset写入磁盘或数据库
     *
     * @return      bool
     */
    protected function _write() {
        //供子类定制
        $msgs = new \wns\BranchTable();
        $msgs->setMaxId($this->_max_id);
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        ksort($this->_recordset);
        foreach ($this->_recordset as $key => $val) {
            $this->_write_callback($val);
            $val = $arrcodec->decode(new \wns\Branch(), $val); //转成对象
            $msgs->addBranchList($val);
        }
        $rs = $this->_write_protobuf_to_xml($msgs->descriptor()->getName(), $msgs, $this->_conf);

        if (!$rs) {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_conf, false); //第二个参数表示此次配置更改是否有风险
        return true;
    }

    /**
     * _read方法的回调函数
     *
     * @param       $record     array       记录
     */
    protected function _read_callback(array & $record) {

    }

    /**
     * _write方法的回调函数
     *
     * @param       $record     array       记录
     */
    protected function _write_callback(array & $record) {
        //供子类定制

    }

    /**
     * 新增
     *
     * @param       $write      bool        是否写入磁盘
     */
    public function create($write = true) {
        if('update' !== $this->_action && 'export_data' !== $this->_action)
        {
            if ($this->uplimit()) {
                if($this->_limit_branch === 0)
                    bug(__("集中管理序列号未开启。"));
                else
                    $this->log->add('error', __('branch_exceed_uplimit', $this->_limit_branch));
                if ('import' === $this->_action)
                {
                    $this->_import_exceed = true;
                }
                return false;
            }
        }
        $record = array('name' => $this->_args['data']['name'],);
        if ($this->is_name_exist($record)) {
            if ('import' === $this->_action)
            {
                ++$this->_import_exist;
            }
            bug(__('该分支名已存在！'));
        }
        $record = array('account' => $this->_args['data']['account'],);
        if ($this->is_account_exist($record)) {
            bug(__('该分支账号已存在！'));
        }
        $record = $this->_args['data'];
        //update的时候也会修改密码
        if($record['pwd'] !== "")
        {
            $record['pwd'] = $this->pwdenc_model->pwdenc($record['pwd']);
        }
        if(isset($this->_args['data']['model']) && $this->_args['data']['model'])
        {
            if(isset($this->_args['data']['model']['text']))
            {
                $model = $this->_args['data']['model']['text'];
                unset($record['model']);
                $record['model'] = $model;
            }
            else 
            {
                $record['model'] = $this->_args['data']['model'];
            }
        }   
        if(isset($this->_args['data']['gateway_sn']))
            $record['gateway_sn'] = $this->_args['data']['gateway_sn'];
        if(isset($record['group_id']))
            $record['group_id'] = intval($record['group_id']);
        if ('update' !== $this->_action && 'export_data' !== $this->_action) //新增
        {
            $record['id'] =  $this->get_loop_record_id();
            $record['net_manage_type'] = isset($this->_args['data']['net_manage_type']) ? $this->_args['data']['net_manage_type'] : \wns\net_manage_e::BRANCH_MANAGE;      
            $this->_recordset[] = $record;
            $this->check_update_area_data($record['group_id']);
            if(!empty($this->_args['data']['model']['text']))
            {
                $this->_inter_update_branch[] = array(
                    'id' => $record['id'],
                    'model' => $this->_args['data']['model']['text'],
                );
            }
        }
        else
        {
            $record['id'] = $this->_args['data']['id'];
            $record['net_manage_type'] = isset($this->_args['data']['net_manage_type']) ? $this->_args['data']['net_manage_type'] : \wns\net_manage_e::BRANCH_MANAGE;
            if(isset($this->_old_record['platform']))
                $record['platform'] = $this->_old_record['platform'];
            if(isset($this->_old_record['cloud_config']))
                $record['cloud_config'] = $this->_old_record['cloud_config'];
            if(isset($this->_old_record['slave_model']))
                $record['slave_model'] = $this->_old_record['slave_model'];
            $this->_recordset[$this->_old_index] = $record;
            if($record['group_id'] != $this->_old_record['group_id'])
            {
                $this->check_update_area_data($record['group_id']);
            }
        }

        //删除本地控制器记录
        if(!isCloudSc())
        {
            $this->delete_local_wac_record();
        }

        //先给分支创建AP配置和目录，创建好后再创建分支。
        if (__FUNCTION__ === $this->_action || 'import' === $this->_action)
        {
            if (__FUNCTION__ === $this->_action)  //导入统一到import接口处理
            {
                //td30758 先创建AP配置，才能创建交换机配置
                $ret = $this->create_branch_conf('AP');
                if($ret !== false)
                {
                    $ret = $this->create_branch_conf('switch');
                }
                if($ret === false)
                {
                    if(!$this->log->has_error())
                    {
                        bug(__("获取数据失败，请检查服务是否已运行"));
                    }
                    return false;
                }
                //更新创建网点的默认语言
                if($record['id'] != CENTER_ID)
                {
                    $this->update_branch_lang($record['id']);
                }
            }
            
            //分支新增时创建文件夹，由后台来维护。
//            分支创建成功，需要新增一个分支配置的文件夹，并加入默认的AP组配置
//            $branch_dir = self::BRANCH_FOLDER . $record['id'];
//            if (is_dir($branch_dir))
//            {
//                exec("rm -rf ".$branch_dir, $output, $code);
//            }
//            if(build_dir($branch_dir) === false)
//            {
//                build_dir($branch_dir); //创建失败，重建一次
//            }
            if('import' === $this->_action)
                return true;
        }
        $this->update_branch_inter_conf();
        $this->update_branch_net_status_conf();
        $rs = parent::create($write);
        if (!$rs) {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_conf));
            if (__FUNCTION__ === $this->_action)
            {
                parent::addLog('controller_cluster',__('添加分支账号 %s',$record['account']),false);
                bug($str);
            }
            return false;
        }
        if (__FUNCTION__ === $this->_action) {
            parent::addLog('controller_cluster', __('添加分支账号 %s', $record['account']), true);
        }
        return true;

    }

    /**
     * 更新创建分支语言与SC一致
     * @param $branch_id
     * @return bool
     */
    protected function update_branch_lang($branch_id)
    {
        $path = ($branch_id == CENTER_ID) ? '' : "branch/$branch_id/";
        $this->load->model('system_management/system_configuration/system_option_model');
        $center_lang = $this->system_option_model->get_option('device_language');
        $conf = config_item('conf_folder') . $path . 'wns_cfg_system_option.xml';
        $namespace = 'wns.system_option';
        $rs = array_from_xml_file($conf, $namespace);
        if(is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        $rs['device_language'] = $center_lang;
        $rs = array_to_xml_file($namespace, $rs, $conf);
        if(0 !== $rs)
        {
            bug(__('unexpected_config'));
        }
        return TRUE;
    }

    /**
     * 更新分支配置
     *
     * @param       $id     分支id
     */
    public function update_branch_sc_info($record)
    {
        $conf = $this->configs['conf_folder']. 'branch/'. $record['id'] . '/wns_cfg_sc_info.xml';
        build_dir(dirname($conf));
        $data = [];
        $data['wac_mode'] = \wns\wac_role_e::BRANCH_E;
        $data['join_sc'] = array(
            'center_addr' => $record['center_addr'],
            'account' => $record['account'],
            'pwd' => $record['pwd'],
            'branch_mode' => \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE,
            'auth_style' => \wns\branch_auth_style::DISTBT_AUTH,
            'gw_id' => $record['gateway_sn'],
            'sw_ver' => trim(exec("busybox head -n 1 /config/cfgversion")),
            'hw_ver' => $record['model'],
        );
        if(isCloudSc())
        {
            $this->load->model('system_management/admin_account/admin_account_model');
            $data['join_sc']['mt_name'] = $this->admin_account_model->get_super_admin_name();
        }
        $rs = array_to_xml_file('wns.sc_info_t', $data, $conf);
        if (0 !== $rs) {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
            return false;
        }
        return true;
    }

    /**
     * 更新本地控制器配置
     *
     * @param       $write      bool        是否写入磁盘
     * @param       $record_bak mixed       原始记录
     */
    public function update_local_wac($write = true, $record_bak = null)
    {
        $record = array('name' => $this->_args['data']['name'],);
        if ($this->is_name_exist($record, $index) && $this->_recordset[$index]['id'] !== CENTER_ID) {
            bug(__('该分支名已存在！'));
        }
        $record['id'] = $record_bak['id'];
        $record['group_id'] = intval($this->_args['data']['group_id']);
        $record['net_manage_type'] = \wns\net_manage_e::BRANCH_MANAGE;
        $record['platform'] = \wns\branch_platform_e::ENTITY;
        if($record['group_id'] != $this->_old_record['group_id'])
        {
            $this->check_update_area_data($record['group_id']);
        }
        $rs = array_to_xml_file('wns.Branch', $record, $this->_local_wac_conf);
        if (0 !== $rs) {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_local_wac_conf));
            if (__FUNCTION__ === $this->_action)
            {
                parent::addLog('controller_cluster',__('更新本地控制器 %s',$record['name']),false);
                bug($str);
            }
            return false;
        }
        if (__FUNCTION__ === $this->_action) {
            parent::addLog('controller_cluster', __('更新本地控制器 %s', $record['name']), true);
        }
    }

    /**
     * 删除本地控制器记录
     *
     * @param       
     */
    public function delete_local_wac_record()
    {
        foreach ($this->_recordset as $key => $val)
        {
            if($val['id'] === CENTER_ID)
            {
                unset($this->_recordset[$key]);
                break;
            }
        }
    }



    public function create_branch_conf($type = 'AP', $branch_id = null)
    {
        $notify_file_dir = $type === 'switch' ? self::TRANSFER_SWCONF_TASK_DIR : self::TRANSFER_APCONF_TASK_DIR;
        $result_file_dir = $type === 'switch' ? self::TRANSFER_SWCONF_RESULT_DIR : self::TRANSFER_APCONF_RESULT_DIR;
        $addcount = count($this->_new_idset);
        $start_time=get_run_time();
        if(is_null($branch_id))
        {
            $addids = implode("\n", $this->_new_idset);
            $transfer_notify = sprintf("%s_1_-1_%d_%d",  $start_time, $addcount, $addcount);
            $notify_file = $notify_file_dir.$transfer_notify;
            $rs = touch($notify_file);
            file_put_contents($notify_file, $addids);
        }
        else{
            $transfer_notify = sprintf("%s_%d_%d_#_#",  $start_time, 1, $branch_id);
            $rs = touch( $notify_file_dir.$transfer_notify);
        }
        $timecount = 120; //等两分钟
        $result_file    = $result_file_dir.$transfer_notify;
        $errorcnt = 5;
        while($timecount--)
        {
            sleep(1);
            if(is_file($result_file))
            {
                $ret = file_get_contents($result_file); //先读APERR的，如果APERR的为空，再去读SWERR的

                if ($ret === '')
                    continue;

                $ret = explode("\n", $ret);
                //错误码0：成功；2：AP组个数超过上限；3：AP个数超过上限；
                //1：mac冲突，在第二行开始每行显示："显示冲突mac;冲突mac所在分支id;名称；类型（是交换机还是接入点）"
                    if(isset($ret[0]))
                    {
                        switch($ret[0])
                        {
                            case '0':
                            return true;
                            case '1':
                            $branch_raw = $this->get_branch_list();
                            foreach($ret as $key => $val)
                            {
                                if($key === 0) //错误码行跳过
                                continue;
                                $val = trim($val);
                                if($val === '')
                                    continue;
                                $val = explode(';', $val);
                                if(!isset($val[2]))
                                    return false;
                                $type = 'AP';
                                if(isset($val[3]) && intval($val[3]) === AP_POE)
                                {
                                    $type = __('交换机');
                                }
                                if(!$errorcnt--) //最多记录5条错误提示
                                break;
                                $branch_id = intval(trim($val[1]));
                                $this->log->add('error', __('MAC地址 {0} 已被分支：{1}的{2}：{3}占用', trim($val[0]),
                                        @$branch_raw[$branch_id]['name'], $type, trim($val[2]))); //MAC已被名称占用
                            }
                            break;
                            case '2':
                            $this->log->add('error', __('本地控制器（包括分支）分组（区域）总个数超过上限 %d。', $this->get_uplimit('limit_ap_group')));
                            break;
                            case '3':
                            $this->log->add('error', __('本地控制器（包括分支）接入点个数超过上限 %d。', $this->get_uplimit('limit_ap_local')));
                            break;
                            case '4':
                            $this->log->add('error', __('分支加载配置出现内部错误，请联系技术支持人员。'));
                            break;
                            case '5':
                            $this->log->add('error', __('本地控制器（包括分支）交换机个数超过上限 %d。', $this->get_uplimit('limit_switch')));
                            break;
                            case '-1':
                            //TD 76626，尝试寻找出错原因
                            foreach ($this->_related_dir as $_dir)
                            {
                                $_percent = get_disk_percent($_dir);
                                if($_percent >= 99)
                                {
                                    $this->log->add('error', __('磁盘空间不足！'));
                                    return false;
                                }
                            }
                            return false;
                        }
                    }
                    return false;
                }
            }
            return false;
        }

    /**
     * 最大记录数
     */
    protected function uplimit() {
        $count = count($this->_recordset) + 1;

        if(!isCloudSc())
        {
            --$count; //td 79527，若为实体sc，则统计时不计入本地控制器
        }

        if ($count > $this->_limit_branch) {
            return true;
        }
        return false;
    }


    /**
     * 判断id是否存在的
     */
    public function has_exists($id) {
        $id = intval($id);
        foreach($this->_recordset as $record) {
            if($record['id'] === $id) {
                return true;
            }
        }
        return false;
    }

    protected function branch_has_apgrp($branch_id)
    {
        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");
        return $this->wl_apgroup_model->branch_has_userdef_conf($branch_id);
    }

    /**
     * 加载AP组配置
     */
    public function load_apgrp_config()
    {
        $sendobj = new \webui_msg\center_req_msg();
        $branch_id = $this->_args['branch_id'];
        if(intval($branch_id) === CENTER_ID)
        {
            bug(__("中心端无法远程加载配置"));
        }
        $branch_raw = $this->get_branch_list();
        if(!$this->branch_has_apgrp($branch_id))
        {
            bug(__("中心端已经给分支：%s配置了接入点（分组）或交换机（分组），请先删除，再加载该分支的配置", $branch_raw[$branch_id]['name']));
        }
        $sendobj->setAccountId($branch_id); //目前服务只支持一次加载1个分支AP组配置
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);

        $replyobj = new \webui_msg\center_rsp_msg();
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_CONFIG_SRVD, 0,
            \wns\msgid_sc_config_svd_e::LOAD_AP_GRP_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::LOAD_AP_GRP_CFG_R, 10);
        if($ret === -2)
        {
            bug(__("与服务通讯超时"));
        }
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getRet();
        if($ret === \webui_msg\msg_result_e::FAULED)
        {
            bug(__('服务执行出错'));
        }
        elseif($ret === \webui_msg\msg_result_e::BRANCH_NOT_ONLINE)
        {
            bug(__('该分支离线或不处于管理模式，无法加载分支配置'));
        }
        elseif($ret === \webui_msg\msg_result_e::BAK_FILE_NOT_EXIST)
        {
            bug(__('该分支的接入点、交换机备份配置不存在'));
        }

        //td30758 先创建AP配置，才能创建交换机配置
        $ret = $this->create_branch_conf('AP', $branch_id);
        if($ret !== false)
        {
            $ret = $this->create_branch_conf('switch', $branch_id);
        }
        if($ret === false)
        {
            if(!$this->log->has_error())
            {
                bug(__("获取数据失败，请检查服务是否已运行"));
            }
            return false;
        }
        parent::addLog('controller_cluster', __('加载分支%s 的接入点、交换机配置', $branch_raw[$branch_id]['name']), TRUE);
        return TRUE;
    }

    /**
     * 立即同步配置
     */
    public function load_sync_config()
    {
        if(isset($this->_args['selectall']) && $this->_args['selectall'])
        {
            $bak_data = $this->_recordset;
            $this->_filter();
            $branchs = $this->_recordset;
            $msg = __('立即同步所有分支的配置');
            $this->_recordset = $bak_data;
        }
        else
        {
            $branchs = $this->_args['data'];
        }
//        if(count($branchs) > $this->_limit_sync_cfg) //与ysq沟通，不做同步分支个数限制
//        {
//            bug(__("最多支持%d个分支同时同步配置", $this->_limit_sync_cfg));
//        }
        $objs = [];
        $sendobj = new \webui_msg\center_req_msgs();
        foreach($branchs as $key => $val)
        {
            $sendobj->addAccountId($val['id']);
            $objs[] = $val['account'];
        }
        if(!isset($msg))
        {
            $msg = __('立即同步以下分支的配置：%s', and_so_on_limit($objs));
        }
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_CONFIG_SRVD, 0,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_R, 0);
        $ret1 = php_wns_ipc_to_self(\wns\module_id_e::AUTH_MOD_WAC_USERORG, 0,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_R, 0);
        parent::addLog('controller_cluster',$msg,true);
        return true;
    }


    /**
     * 立即同步本地用户配置
     */
    public function load_sync_localusr_config($branchId = 0)
    {
        $sendobj = new \webui_msg\center_req_msgs();
        $sendobj->setIsAll(true);
        $sendobj->setAccountId($branchId);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_CONFIG_SRVD, 0,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_R, 0);
        $ret1 = php_wns_ipc_to_self(\wns\module_id_e::AUTH_MOD_WAC_USERORG, 0,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_R, 0);
        return true;
    }

    private function update_ref_wlan($mode, $branchmap)
    {
        $center = ($mode === \wns\central_mgmt_mode_e::CENTRAL_SHUNT_MODE);
        $distr = ($mode === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE);
        if(!$center && !$distr)
            return true;
        $this->updateWlanApsForBranchMode($center, $branchmap);
        return true;
    }

    /**集中认证和分布式认证模式更新WLAN接入点配置
     * @param $centerAuth
     * @param $branchmap
     */
    public function updateWlanApsForBranchMode($centerAuth, $branchmap)
    {
        //无线网络或接入点有线认证
        if(is_center_wac())
            $confs = [$this->configs['conf_folder'] . 'sc_wns_cfg_wl_wlan_ui.xml',
        $this->configs['conf_folder'] . 'sc_wns_cfg_wl_ap_wired_ui.xml'];
        else
            $confs = [$this->configs['conf_folder'] . 'wns_cfg_wl_wlan_ui.xml',
        $this->configs['conf_folder'] . 'wns_cfg_wl_ap_wired_ui.xml'];

        foreach($confs as $conf)
        {
            $rs = array_from_xml_file($conf, 'wns.cfg_wlan_list');
            $needwrite = false;
            foreach($rs['wlan_list'] as $key => &$wlan)
            {
                if(($centerAuth && @$wlan['wlan_basic']['filter_type'] === \wns\wlan_center_auth_method_e::WLAN_AUTH_DISTR)
                    || (!$centerAuth && @$wlan['wlan_basic']['filter_type'] === \wns\wlan_center_auth_method_e::WLAN_AUTH_CENTER))
                    //已经配置了分布式认证网点ssid、切换成集中认证 || 已经配置了集中认证网点ssid、切换成分布式认证
                {
                    if(!empty($wlan['branch_list']))
                    {
                        foreach($wlan['branch_list'] as $i => $branch)
                        {
                            if(isset($branchmap[$branch['branch_id']]))
                            {
                                if(!empty($wlan['ap_id']) && !empty($branch['ap_id']))
                                    $wlan['ap_id'] = array_diff($wlan['ap_id'], $branch['ap_id']);
                                if(!empty($wlan['group_id']) && !empty($branch['group_id']))
                                    $wlan['group_id'] = array_diff($wlan['group_id'], $branch['group_id']);
                                if($branch['is_all_grp']) //防止写了该网点的所有区域的id
                                {
                                    static $branch_root_apgid = null; //所有分支的“所有区域”的id
                                    if(is_null($branch_root_apgid))
                                    {
                                        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");
                                        $branch_root_apgid = $this->wl_apgroup_model->get_branch_root_id();
                                    }
                                    if(isset($branch_root_apgid[$branch['branch_id']]))
                                    {
                                        $wlan['group_id'] = array_diff($wlan['group_id'], [$branch_root_apgid[$branch['branch_id']]]);
                                    }
                                }
                                unset($wlan['branch_list'][$i]);
                                $needwrite = true;
                            }
                        }
                    }
                }
            }
            if($needwrite)
            {
                array_to_xml_file('wns.cfg_wlan_list', $rs, $conf);
            }
            unset($rs);
        }
        return true;
    }


    /**
     * 更新同频服务
     */
    protected function update_ref_frq_grp()
    {
        //如果从分布式认证切换到集中认证，删除同频服务中引用了该分支的接入点
        $branch_ids = [];
        $this->load->model('wireless_configure/wireless_ap/Wl_virtual_frqgrp_model');
        foreach($this->_args['rs'] as $branch)
        {
            if($branch['old_mode'] == 'mgmt' && $this->_args['mode'] == 'center_auth')
            {
                $branch_ids[] = $branch['id'];
            }
        }
        $this->Wl_virtual_frqgrp_model->delete_frq_ap_by_branch_ids($branch_ids);
    }


    /**
     * 切换分支模式
     */
    public function switch_branch_mode()
    {
        $modemsg = '';
        $switch_branches = array_column($this->_args['rs'], 'id');
        $reference_branchs=$this->reference_check($switch_branches,$this->_args['rs']);
        if(!empty($reference_branchs)){
            bug(__('分支{0}在功能配置->接入点策略->无线漫游域->漫游控制器中被引用,无法切换模式', and_so_on($reference_branchs)));
            return  false;
        }
        if($this->_args['mode'] === 'mgmt') //按照当前模式获取切换的模式
        {
            $modemsg = __('分布式管理模式');
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
        }
        elseif($this->_args['mode'] === 'monitor') //按照当前模式获取切换的模式
        {
            $modemsg = __('监控模式');
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE;

        }
        else
        {
            $modemsg = __('维护模式');
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE;
        }
        $sendobj = new \webui_msg\center_change_branch_mode_req();
        if(isset($this->_args['selectall']) && $this->_args['selectall'])
        {
            $bak_data = $this->_recordset;
            $this->_filter();
            $branchs = $this->_recordset;
            $msg = __('切换所有分支的工作模式为 %s', $modemsg);
            $this->_recordset = $bak_data;
        }
        else
        {
            $branchs = $this->_args['rs'];
        }
        $objs = [];
        $branchmap = $disasterBranch = [];
        foreach($branchs as $key => $val)
        {
            $sendobj->addAccountId($val['id']);//中心端需要提供是切换哪个分支的模式
            $branchmap[intval($val['id'])] = true;
            $objs[] = $val['name'];
            if($this->sc_disaster_group_model->branchInGroup($val['id'])){
                $disasterBranch[] = $val['name'];
            }
        }
        if(!empty($disasterBranch) && $mode == \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE){
            bug(__('已加入灾备组的分支 %s 不能切换至监控模式', and_so_on_limit($disasterBranch)));
        }
        $this->update_ref_wlan($mode, $branchmap);
        $this->update_ref_frq_grp();
        if(!isset($msg))
        {
            $msg = __('切换以下分支的工作模式为{0}：{1}', $modemsg, and_so_on_limit($objs));
        }
        $sendobj->setMode($mode);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);

        $replyobj = new \webui_msg\center_change_branch_mode_resp();
        //切换通知到sc_proxyd模块
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::CHANGE_BRANCH_MODE_C, $req,
            \wns\webui_msgid_sc_e::CHANGE_BRANCH_MODE_R, 3);
        /*
        if($ret === -2)
        {
            bug(__("与服务通讯超时"));
        }
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getChangeRet();
        if($ret !== \webui_msg\change_result_e::CHANGE_SUCCESSED)
        {
            if($ret === \webui_msg\change_result_e::VERSION_DIFF)
            {
                bug(__('中心端和分支的版本不一致，无法切换'));
            }
        elseif($ret === \webui_msg\change_result_e::KBVERSION_DIFF)
        {
                bug(__('中心端和分支的KB包版本不一致，无法切换'));
            }
            elseif($ret === \webui_msg\change_result_e::BRANCH_OFFLINE)
            {
                bug(__('分支离线，无法切换模式'));
            }
            else
            {
                bug(__('分支工作模式切换失败'));
            }
            return false;
        }*/
        parent::addLog('controller_cluster',$msg, true);

        return true;
    }

    protected function check_conf_legal($branch_id)
    {
        $branch_folder = '/wns/etc/config/wac/branch/';
        $conf = $branch_folder.$branch_id.'/wns_cfg_wired_policy_ui.xml';
        if(file_exists($conf))
        {
            $rs = array_from_xml_file($conf, 'wns.cfg_wired_list');
            if(is_null($rs) || -1 === $rs) {
                bug(__('unexpected_config'));
            }
            if(empty($rs['wired_list']))
            {
                return true;
            }
            foreach($rs['wired_list'] as $val)
            {
                if($val['wired_basic']['portal_sub'] === \wns\wlan_portal_sub_type_e::PORTAL_SUBTYPE_LOCAL_PORTAL)
                    {
                        return false;
                    }
                }
            }
            return true;
        }

    /**
     * 分支端切换分支模式
     */
    public function switch_self_mode()
    {
        if($this->_sc_info['join_sc']['branch_mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
            {
                $this->_sc_info['join_sc']['branch_mode'] = \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE;
                $wac_role = MONITOR_BRANCH;
            }
            else
            {
                $this->_sc_info['join_sc']['branch_mode'] = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
                $wac_role = MGMT_BRANCH;
            }

            $sendobj = new \webui_msg\branch_change_mode_req();
        $sendobj->setReleasePwd($this->_args['data']['pwd']); //分支端切换模式需要安全密码（与解控密码一致）
        $sendobj->setMode($this->_sc_info['join_sc']['branch_mode']);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);

        $replyobj = new \webui_msg\branch_change_mode_resp();
        //切换通知到sc_proxyd模块
        $ret_prxyd = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::CHANGE_MODE_C, $req,
            \wns\webui_msgid_sc_e::CHANGE_MODE_R, 10);
        $obj = $bincodec->decode($replyobj, $ret_prxyd['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getChangeRet();
        if($ret !== \webui_msg\change_result_e::CHANGE_SUCCESSED)
            {
                if($ret === \webui_msg\change_result_e::VERSION_DIFF)
                    {
                        bug(__('中心端和分支的版本不一致，无法切换'));
                    }
                    elseif($ret === \webui_msg\change_result_e::BRANCH_OFFLINE)
                        {
                            bug(__('分支离线，无法切换模式'));
                        }
                        else
                        {
                            bug(__('切换失败，解控密码错误'));
                        }
                        return false;
                    }
        //切换成功，保存配置
                    $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
                    $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);

                    $this->_wac_role = $wac_role;
        //td44965 切换控制器角色的配置放在切换完再最后保存，防止切换过程中，页面被刷新到首页
                    $this->_sc_info_msg = $msg;
                    parent::addLog('controller_cluster',__('切换分支的工作模式'), true);
                    return true;
//        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf);
//
//        if (!$rs)
//        {
//            $str = __('config_unwritable');
//            $this->log->add('debug', array($str, $this->_scinfo_conf));
//            bug($str);
//        }
//        $this->load->model('php_config_model');
//        $this->php_config_model->add($this->_scinfo_conf);
//        return true;
                }


    /**
     * 中心端切换分支模式、分支端修改配置中的模式——提供给后台调用
     */
    public function modify_sc_mode($mode)
    {
        $mode = intval($mode);
        $sess_wac_role = $this->session->userdata(Runtime_Model::WACROLE); //切换前WAC角色
        $wac_role = MGMT_BRANCH;
        if($mode === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)//分布式认证
        {
            $this->_sc_info['join_sc']['auth_style'] = \wns\branch_auth_style::DISTBT_AUTH;
        }
        if($mode === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ) //分支端只有管理模式，维护模式认为是特殊的管理模式
        {
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
            $this->_sc_info['join_sc']['auth_style'] = \wns\branch_auth_style::DISTBT_AUTH;
        }
        if($mode === \wns\central_mgmt_mode_e::CENTRAL_SHUNT_MODE)//集中认证
        {
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
            $this->_sc_info['join_sc']['auth_style'] = \wns\branch_auth_style::CENTER_AUTH;
        }
        if($mode === \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE)
            {
                $wac_role = MONITOR_BRANCH;
            }
        if (0 !== strcmp($wac_role, $sess_wac_role)) //WAC角色切换
        {
            if($wac_role === MGMT_BRANCH) //切换成集中管理的分支需要备份AP配置
            {
                $this->save_old_ap_config();
                //切换至管理分支时自动设置为使用中心端配置
                $this->load->model("system_management/sys_sms/sys_sms_model");
                $this->sys_sms_model->set_enable_advance_switch();
            }
            if($sess_wac_role === MGMT_BRANCH) //从集中管理的分支切换
            {
                $this->load->model("system_management/sys_sms/sys_sms_model");
                $this->sys_sms_model->set_default_advance_switch();
            }
        }
        $this->_sc_info['join_sc']['branch_mode'] = intval($mode);
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);
        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf);

        if (!$rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_scinfo_conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_scinfo_conf);
        return true;
    }

    public function get_wac_branch_name()
    {
        if(strstr($this->_wac_role, "branch"))
        {
            $replyobj = new \webui_msg\branch_stat_info_resp();
            $bincodec = new \DrSlump\Protobuf\Codec\Binary();
            $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
                \wns\webui_msgid_sc_e::BRANCH_INFO_C, '',
                \wns\webui_msgid_sc_e::BRANCH_INFO_R, 3);
            if($ret !== null && $ret !== -2)
            {
                $obj = $bincodec->decode($replyobj, $ret['buf']);
                $retdata = $this->_conv_msgObj_to_array($obj);
                return $retdata['branch_name'];
            }
        }
        return '';
    }

    protected function _check_center_addr($center_addr, $isbak = false)
    {
        if(!isset($center_addr) || $center_addr === '')
            return true;
        $this->load->model('wireless_configure/advance_option/wl_option_model');
        $webagent_url = $this->wl_option_model->get_option('webagent_url');
        $bak_webagent_url = $this->wl_option_model->get_option('webagent_backup');
        if($webagent_url === $center_addr)
        {
            if($isbak)
                bug(__("中心端备地址 配置有误，不允许与系统配置->系统选项->主webAgent配置相同地址。"));
            else
                bug(__("中心端主地址 配置有误，不允许与系统配置->系统选项->主webAgent配置相同地址。"));
        }

        if($bak_webagent_url === $center_addr)
        {
            if($isbak)
                bug(__("中心端备地址 配置有误，不允许与系统配置->系统选项->备webAgent配置相同地址。"));
            else
                bug(__("中心端主地址 配置有误，不允许与系统配置->系统选项->备webAgent配置相同地址。"));
        }
        return true;
    }

    /**
     * 切换控制器角色
     */
    public function switch_wac_role()
    {
        $msg = new \wns\sc_info_t();
        $old_role = $this->session->userdata(Runtime_Model::WACROLE);
        $role = $this->_args['data']['wac_mode'];
        if($role === INDEPENDENT)
        {
            if($old_role === CENTER)
            {
                //中心端退出，需要先清空集中管理分支
                if(!empty($this->_recordset))
                {
                    $old_args = $this->_args;
                    $this->_args['data'] = $this->_recordset;
                    $this->delete();
                    if(is_dir(self::BRANCH_FOLDER))
                    {
                        $this->exec("rm -rf " . self::BRANCH_FOLDER . '*', $output, $code);
                    }
                    $this->_args = $old_args;
                }
            }
            $msg->setWacMode(\wns\wac_role_e::INDEPENDENT_E);
            $opr_log = __("退出集中管理");
            $this->switchScToIndependentDefaultConf();
        }
        elseif($role === CENTER)
        {
            if($this->_limit_branch == 0)
            {
                bug(__("集中管理序列号未开启。"));
            }
            $msg->setWacMode(\wns\wac_role_e::CENTER_E);
            $opr_log = __("加入集中管理，设备切换成中心端");
            //加入集中管理中心端，首次加入需要设置密码
            $this->set_global_release_pwd();
            $rs = $this->switchIndependentToScConf();
            if(!$rs)
            {
                bug(__('配置转换失败'));
            }
        }
        else /*分支控制器*/
        {
            $msg->setWacMode(\wns\wac_role_e::BRANCH_E);
            //分支控制器需要输入加入集中管理的信息
            $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
            $sc_info = $this->_args['data']['join_sc'];
            $mode = $sc_info['branch_mode'];
            $this->_check_center_addr($sc_info['center_addr']);
            $this->_check_center_addr(@$sc_info['bakup_center_addr'], TRUE);
            if($mode === 'mgmt')
            {
                $sc_info['branch_mode'] = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
            }
            elseif($mode === 'monitor')
            {
                $sc_info['branch_mode'] = \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE;
            }
            else
                bug(__("分支不支持切换成该模式"));
            $sc_info['pwd'] = $this->pwdenc_model->pwdenc($sc_info['pwd']);
            $joininfo = $arrcodec->decode(new \wns\join_sc_t(), $sc_info);
            $msg->setJoinSc($joininfo);
            $role = $mode . '_branch';
            $opr_log = __("加入集中管理，设备切换成分支");
        }
        $this->_wac_role = $role;
        //td44965 切换控制器角色的配置放在切换完再最后保存，防止切换过程中，页面被刷新到首页
        $this->_sc_info_msg = $msg;
        parent::addLog('controller_cluster', $opr_log, TRUE);
        return TRUE;
    }

    /**
     * 独立切换SC配置转换
     * @return bool
     */
    protected function switchIndependentToScConf()
    {
        $cmd = '/wns/3party/php/bin/php /wns/webui/index.php conf_upgrade_for_sdwan upgradeIndependentToSC';
        exec($cmd, $ret, $code);
        if($code != 0){
            return false;
        }
        return true;
    }

    /**
     * SC切换到独立的时候恢复部分默认配置
     * @return bool
     */
    protected function switchScToIndependentDefaultConf()
    {
        $cmd = '/wns/3party/php/bin/php /wns/webui/index.php conf_upgrade_for_sdwan copyDefaultToScConf';
        exec($cmd, $ret, $code);
        if($code != 0){
            return false;
        }
        return true;
    }

    /**
     * 分支切换到独立配置处理
     *
     * @return bool
     */
    protected function switch_branch_to_independent_default_conf()
    {
        $confs_to_default = array('wns_cfg_disaster_group.xml',);
        try
        {
            foreach($confs_to_default as $file)
            {
                $defaultFile = $conf = $this->configs['default_conf_folder'] . $file;
                $confFfile = $conf = $this->configs['conf_folder'] . $file;;
                $this->copyConfToSC($defaultFile, $confFfile);
            }
        }
        catch(Exception $e)
        {
            return FALSE;
        }
        return TRUE;
    }

    protected function copyConfToSC($depFile, $scFile)
    {
        $cmd = "cp -f $depFile $scFile;filesum -m $scFile";
        exec($cmd, $ret, $code);
        if($code!=0){
            log_message_r('error', "cp conf failure: $depFile=>$scFile");
            bug(__('配置拷贝失败'));
        }
    }

    public function _write_sc_conf()
    {
        $data = $this->_conv_msgObj_to_array($this->_sc_info_msg);
        $rs = array_to_xml_file('wns.sc_info_t', $data, $this->_scinfo_conf);
        if (0 !== $rs)
        {
            log_message_r('error', __('配置保存失败 %s', $this->_scinfo_conf));
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_scinfo_conf));
            bug($str);
        }

        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_scinfo_conf);
        return true;
    }
    /**
     * 保存旧的AP配置
     */
    public function save_old_ap_config()
    {
        build_dir(self::MGMT_AP_BAK);
        $cmd = "cp -f /wns/etc/config/wac/wns_cfg_wl_ap.xml ". self::MGMT_AP_BAK. "wns_cfg_wl_ap.xml";
        $cmd = $cmd. "; cp -f /wns/etc/config/wac/wns_cfg_wl_sw.xml ". self::MGMT_AP_BAK. "wns_cfg_wl_sw.xml";
        $cmd = $cmd. "; cp -f /wns/etc/config/wac/wns_cfg_wl_apgroup.xml ". self::MGMT_AP_BAK. "wns_cfg_wl_apgroup.xml";
        $cmd = $cmd. "; cp -f /wns/etc/config/wac/wns_cfg_wl_swgroup.xml ". self::MGMT_AP_BAK. "wns_cfg_wl_swgroup.xml";
        $cmd = $cmd. "; cp -f /wns/etc/config/wac/wns_cfg_wl_apgroup_param.xml ". self::MGMT_AP_BAK. "wns_cfg_wl_apgroup_param.xml";
        exec($cmd, $output, $code);
        $this->exec('/wns/sbin/filesum -m '.self::MGMT_AP_BAK. '*');
        //这里发一次配置更新消息
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_scinfo_conf);
        if($code === 0)
            return true;
        bug($output[0]);
    }

    /**
     * 分支修改SC基本信息
     */
    public function modify_sc_info()
    {
        php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
         \wns\webui_msgid_sc_e::CONNECT_SC_C, "", 0, 3); //发消息获取

        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $this->_sc_info['join_sc']['center_addr'] = $this->_args['data']['center_addr'];
        $this->_sc_info['join_sc']['bakup_center_addr'] = $this->_args['data']['bakup_center_addr'];
        $this->_check_center_addr($this->_sc_info['join_sc']['center_addr']);
        $this->_check_center_addr(@$this->_sc_info['join_sc']['bakup_center_addr'], true);
        $this->_sc_info['join_sc']['account'] = $this->_args['data']['account'];
        $this->_sc_info['join_sc']['pwd'] = $this->pwdenc_model->pwdenc($this->_args['data']['pwd']);
        $this->_sc_info['join_sc']['mt_name'] = $this->_args['data']['tenant_name'];
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);
        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf);

        if (!$rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_scinfo_conf));
            bug($str);
        }
        $this->save_old_ap_config(); //td50936 编辑分支账号提交时需要重新备份接入点配置

        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_scinfo_conf);
        parent::addLog('controller_cluster',__('编辑分支账号'), true);
        return true;
    }
    /**
     * 测试与中心端连通性
     */
    public function test_conn()
    {
        $sendobj = new \webui_msg\branch_check_conn_req();
        $sendobj->setCenterAddr($this->_args['data']['center_addr']);
        $sendobj->setAccount($this->_args['data']['account']);
        $sendobj->setPwd($this->_args['data']['pwd']);
        if(!empty($this->_args['data']['tenant_name']))
            $sendobj->setMtName($this->_args['data']['tenant_name']);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $replyobj = new \webui_msg\branch_check_conn_resp();
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::CHECK_CONN_C, $req,
            \wns\webui_msgid_sc_e::CHECK_CONN_R, 15);
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }
        $ret = $obj->getConnRet();
        switch($ret)
        {
            case \webui_msg\conn_result_e::CONN_SUCCESSED:
            $this->log->add('error', __("%s：连接成功", __('中心端主地址')));
            break;
            case \webui_msg\conn_result_e::CONN_ACCOUNT_NONE:
            $this->log->add('error', __("%s：账号不存在", __('中心端主地址')));
            break;
            case \webui_msg\conn_result_e::CONN_PASSWORD_ERR:
            $this->log->add('error', __("%s：密码错误", __('中心端主地址')));
            break;
            case \webui_msg\conn_result_e::CONN_DEV_ERR:
            $this->log->add('error', __("%s：当前账号与网点%s绑定，如需更换网点设备，请先到集中管控的控制器管理页面解绑。", __('中心端主地址'), $obj->getBranchName()));
            break;
            case \webui_msg\conn_result_e::CONN_SLAVE_WAC:
            bug(__("备机不支持集中管理"));
            break;
            case \webui_msg\conn_result_e::CONN_FAILED:
            default:
            $this->log->add('error', __("%s：网络不通,请检查中心端地址（IP、端口等）是否正确", __('中心端主地址')));
            break;
        }
        if(!isset($this->_args['data']['bakup_center_addr']) || $this->_args['data']['bakup_center_addr'] === '')
            return true;
        $sendobj->setCenterAddr($this->_args['data']['bakup_center_addr']);
        $req = $bincodec->encode($sendobj);
        $replyobj = new \webui_msg\branch_check_conn_resp();
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::CHECK_CONN_C, $req,
            \wns\webui_msgid_sc_e::CHECK_CONN_R, 15);
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getConnRet();
        switch($ret)
        {
            case \webui_msg\conn_result_e::CONN_SUCCESSED:
            $this->log->add('error', __("%s：连接成功", __('中心端备地址')));
            break;
            case \webui_msg\conn_result_e::CONN_ACCOUNT_NONE:
            $this->log->add('error', __("%s：账号不存在", __('中心端备地址')));
            break;
            case \webui_msg\conn_result_e::CONN_PASSWORD_ERR:
            $this->log->add('error', __("%s：密码错误", __('中心端备地址')));
            break;
            case \webui_msg\conn_result_e::CONN_DEV_ERR:
            $this->log->add('error', __("%s：当前账号与网点%s绑定，如需更换网点设备，请先到集中管控的控制器管理页面解绑。", __('中心端主地址'), $obj->getBranchName()));
            break;
            case \webui_msg\conn_result_e::CONN_SLAVE_WAC:
            bug(__("备机不支持集中管理"));
            break;
            case \webui_msg\conn_result_e::CONN_FAILED:
            default:
            $this->log->add('error', __("%s：网络不通,请检查中心端地址（IP、端口等）是否正确", __('中心端备地址')));
            break;
        }
        if($this->log->has_error())
        {
            $this->log->flush();
        }
        return true;
    }

    /**
     * 设置全局解控密码
     */
    public function set_global_release_pwd()
    {
        $msg = new \wns\branch_release_pwd();
        $pwd = $this->_args['data']['pwd'];
        if($pwd !== "")
        {
            $pwd = $this->pwdenc_model->pwdenc($pwd);
        }
        $msg->setPwd($pwd);
        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_global_pwd_conf);

        if (!$rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_global_pwd_conf));
            bug($str);
        }

        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_global_pwd_conf);
        if($this->_action === __FUNCTION__)
        {
            parent::addLog('controller_cluster',__('设置全局解控密码'), true);
        }
        return true;
    }

    public function get_global_release_pwd()
    {
        $msg = new \wns\branch_release_pwd();
        $rs = $this->_read_protobuf_from_xml($msg->descriptor()->getName(), $msg, $this->_global_pwd_conf);
        $pwd = $this->pwdenc_model->pwd_dencypt($msg->getPwd());
        $ret = array(
            'pwd'=>$pwd,
            'pwd_confirm'=>$pwd,
        );
        return $ret;
    }

    
    /**
     * 设置全局解控密码
     */
    public function need_validate_pwd()
    {
        $msg = new \wns\branch_release_pwd();
        $this->_read_protobuf_from_xml($msg->descriptor()->getName(), $msg, $this->_global_pwd_conf);
        $join_suc = intval($msg->getEverJoinSuc());
        if($join_suc)
        {
            return true; //需要校验密码
        }
        //退出成功，保存配置
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $this->_sc_info = array('wac_mode' => \wns\wac_role_e::INDEPENDENT_E);
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);
        $this->_wac_role = INDEPENDENT;
        //td44965 切换控制器角色的配置放在切换完再最后保存，防止切换过程中，页面被刷新到首页
        $this->_sc_info_msg = $msg;
        parent::addLog('controller_cluster',__('退出集中管理'), true);
        return false;
    }

    
    /**
     * 设置某个分支临时解控密钥
     */
    public function set_single_branch_pwd()
    {
        $gateway = $this->_args['data']['gateway'];
        $pwd = "";
        if($gateway !== "")
        {
            $cmd = sprintf('%s "%s"', static::CMD_PWDENC, escape_pwd($gateway));
            $rs = exec($cmd, $output, $code);
            if (0 === $code)
            {
                $pwd = $rs;
            }
            else
            {
                $this->log->add('debug', array($cmd, $output, $code));
                bug(__('fail_to_encrypt_password'));
            }
        }
        parent::addLog('controller_cluster',__('设置分支临时解控密码'), true);
        return $pwd;
    }

    /**
     * 分支申请解控
     */
    public function branch_get_released()
    {
        $sendobj = new \webui_msg\branch_release_req();

        $sendobj->setReleasePwd($this->_args['data']['pwd']);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $replyobj = new \webui_msg\branch_release_resp();

        //切换通知到sc_proxyd模块
        $ret_prxyd = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::BRANCH_RELEASE_C, $req,
            \wns\webui_msgid_sc_e::BRANCH_RELEASE_R, 10);
        $obj_prxyd = $bincodec->decode($replyobj, $ret_prxyd['buf']);
        if($obj_prxyd === NULL)
        {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj_prxyd->getReleaseRet();
        if($ret !== \webui_msg\release_result_e::RELE_SUCCESSED)
        {
            bug(__('解控失败，密码错误'));
            return FALSE;
        }
        $conf_ret = $this->switch_branch_to_independent_default_conf();
        if($conf_ret === FALSE)
        {
            bug(__('解控失败，恢复部分默认配置失败'));
        }
        //退出成功，保存配置
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $this->_sc_info = array('wac_mode' => \wns\wac_role_e::INDEPENDENT_E);
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);
        $this->_wac_role = INDEPENDENT;
        //td44965 切换控制器角色的配置放在切换完再最后保存，防止切换过程中，页面被刷新到首页
        $this->_sc_info_msg = $msg;
        parent::addLog('controller_cluster', __('退出集中管理'), TRUE);
        return TRUE;
    }


    /**
     * 获取分支远程登录信息
     */
    public function get_branch_login_info()
    {
        $sendobj = new \wns\webui_so_req();
        $sendobj->setAccountId($this->_args['data']['id']);
        $record['id'] = intval($this->_args['data']['id']);
        $this->is_id_exist($record, $index);
        $account = '';
        if(!is_null($index))
        {
            $account = $this->_recordset[$index]['account'];
        }
        $sendobj->setDstPort($this->_args['data']['https_port']);
        $is_slave = false;
        $is_super = false;
        $role = $this->session->userdata('gid');
        if (ROLE_SUPER === $role)
        {
            $is_super = true;
        }
        if($this->_args['data']['slave_sso_ip'] !== "")
        {
            if($record['id'] === CENTER_ID)
            {
                parent::addLog('controller_cluster',__('单点登录分支 %s 的备机。', $account), true);
                return array('is_super'=>intval($is_super));
            }
            $sendobj->setDstHostIp($this->_args['data']['slave_sso_ip']);
            $is_slave = true;
        }
        elseif($this->_args['data']['master_sso_ip'] !== "")
            $sendobj->setDstHostIp($this->_args['data']['master_sso_ip']);
        else
            bug(__('参数错误'));
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $replyobj = new \wns\webui_so_resp();
        //切换通知到tcpproxyd模块
        $ret = php_wns_ipc_to_self(\wns\module_id_e::TCP_PROXYD, 0,
            \wns\webui_msgid_so_e::SIGN_ON_BRANCH_REQ, $req,
            \wns\webui_msgid_so_e::SIGN_ON_BRANCH_RESP, 3);
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getResult();
        if(!$ret || $ret->getCode() !== \wns\tcpproxy_error_e::ERROR_SUCCESS)
            {
                $msg = $ret->getMsg();
                bug($msg);
            }
            $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $rs = $arrcodec->encode($obj); //转成数组

        $this->load->model('system_management/admin_account/admin_account_model');

        
        if($is_slave)
        {
            parent::addLog('controller_cluster',__('单点登录分支 %s 的备机。', $account), true);
        }
        else{
            parent::addLog('controller_cluster',__('单点登录分支 %s。', $account), true);
        }

        //生成token
        $token = '';
        if(!is_null($index))
        {
            $this->load->library('SF_JWT');
            $info['name'] = $this->_recordset[$index]['name'];
            $info['id']   = $this->_recordset[$index]['id'];
            $token = $this->sf_jwt->encode($info);
        }

        return array('port' => $rs['proxy_port'],'is_super'=>intval($is_super),'token' => $token);
    }


    /**
     * 获取分支远程登录端口 —— 给分支单点登录访问数据中心
     */
    public function get_branch_login_port()
    {
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $replyobj = new \wns\webui_so_resp();
        //切换通知到tcpproxyd模块
        $ret = php_wns_ipc_to_self(\wns\module_id_e::TCP_PROXYD, 0,
            \wns\webui_msgid_so_e::SIGN_ON_BRANCH_REQ, '',
            \wns\webui_msgid_so_e::SIGN_ON_BRANCH_RESP, 5);
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            return false;
        }

        $ret = $obj->getResult();
        if(!$ret || $ret->getCode() !== \wns\tcpproxy_error_e::ERROR_SUCCESS)
            {
                return false;
            }
            $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $rs = $arrcodec->encode($obj); //转成数组

        return $rs['proxy_port'];
    }



    protected function _delete_deposit_cfg($deposit_branch, $del_deposit)
    {
        $new_deposit_conf = array();
        foreach($deposit_branch as $branch => $val)
        {
            if(isset($del_deposit[$branch]))
            {
                continue;
            }
            $new_deposit_conf[] = array('id' => $branch, 'type' => 'branch', 'path' => null);
        }

        $form['data']['deposit'] = $new_deposit_conf;
        if ($this->assert_form($form, 'deposit_branch_apcfg')) //表单断言
        {
            $this->deposit_branch_apcfg();
        }
    }

    /**
     * 分支托管
     */
    public function deposit_branch_apcfg() {
        $branch_ids = $this->_args['data']['deposit'];
        $f = new \pkg\form\admin_account\APsFieldSet('net', null, __('分支'));

        $f->setDisplayValue(array('net' => $branch_ids));
        $data = $f->getRealValue();
        $deposit = [];
        $deposit_branch_set = [];
        if(isset($data['aps_data']))
        {
            $deposit['deposit_account_id'] = $data['aps_data'];
            $deposit_branch_set = array_flip($data['aps_data']);
        }
        if(isset($data['bgrp_data']))
        {
            $deposit['deposit_grp_id'] = $data['bgrp_data'];
            $this->get_all_branchset_by_bgroup_for_deposit($data['bgrp_data'],$deposit_branch_set);

        }
        $rs = array_to_xml_file('wns.cfg_ap_deposit', $deposit, $this->_deposit_conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_deposit_conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_deposit_conf);
        if($this->_action === __FUNCTION__)
            parent::addLog('controller_cluster',__('保存托管配置'),true);
        $this->update_config_after_deposit_change($deposit_branch_set);
        //$this->update_center_auth_deposit(); //wns3.2R4不限制集中认证必须托管
        return true;
    }

    /**
     * 获取网点分组包含的所有集中管理的分支    for deposit
     * @param $bgroup                   托管分组
     * @param $deposit_branch_set       托管分组网点map集合
     */
    public function get_all_branchset_by_bgroup_for_deposit($bgroup,&$deposit_branch_set)
    {

        $this->load->model('sys_configure/central_monitor/central_area_model');
        $allgrpids = [];
        $this->central_area_model->get_all_group_id($bgroup, $allgrpids);
        if(!empty($allgrpids))
        {
            $this->get_real_branch_list();
            foreach($this->_recordset as $val)
            {
                if(isset($allgrpids[$val['group_id']]) && isset($val['mode']) &&
                    ($val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                        $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
                {
                    $deposit_branch_set[$val['id']] = $val['id'];
                }
            }
        }
    }

    //更新集中管理分支
    public function update_center_auth_deposit()
    {
        $center_auth_set = array();
        $this->get_real_branch_list();
        $center_auth = array_flip($this->sc_disaster_group_model->getCenterAuthBranch());
        foreach($this->_recordset as $val)
        {
            if(isset($val['mode']) &&
                ($val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                    $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
            {
                if(isset($center_auth[$val['id']]))
                {
                    $center_auth_set[$val['id']] = $val['id'];
                }
            }

        }
        $rs = $this->modify_center_auth($center_auth_set);
        if(!$rs)
            bug(__('集中认证分支保存失败'));
        return $rs;
    }

    public function get_deposit_info()
    {
        $rs = array_from_xml_file($this->_deposit_conf , 'wns.cfg_ap_deposit');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        $ret = ['bgrp'=>array(),'branch'=>array()];
        if(isset($rs['deposit_grp_id']))
        {
            foreach($rs['deposit_grp_id'] as $val)
            {
                $ret['bgrp'][$val] = $val;
            }
        }
        if(isset($rs['deposit_account_id']))
        {
            foreach($rs['deposit_account_id'] as $val)
            {
                $ret['branch'][$val] = $val;
            }
        }
        return $ret;
    }
    /**
     * 读托管的分支
     *
     */
    public function get_deposit_branch_list($branch_id_1 = null) {

        $this->db->select('*')->from('deposit_branch_info');
        if($branch_id_1 !== null){
            $this->db->where('branch_id_1',$branch_id_1);
        }
        $rs = $this->db->get()->result_array();
        $deposit_branch_id = array();
        foreach($rs as $key => $val)
        {
            $id = intval($val['branch_id']);
            $deposit_branch_id[$id] = $id;
        }
        return  $deposit_branch_id;
    }

    /**
     * 读托管的分支
     */
    public function get_deposit_branch_info() {
        $deposit_branch_id = $this->get_deposit_branch_list();
        $branch_raw = $this->get_branch_list();
        $depositlist = array();
        foreach ($deposit_branch_id as $key => $val) {
            $depositlist[$val] = array(
                'id' => $val,
                'name' => $branch_raw[$val]['name'],
            );
        }
        return  $depositlist;
    }

    /**
     * 读托管的分支——键值hash
     */
    public function get_deposit_branch_map() {
        static $ret = null;
        if(is_null($ret))
        {
            $deposit = $this->get_deposit_branch_list();
            $ret = array();
            foreach($deposit as $val)
            {
                $ret[$val] = true;
            }
        }
        return $ret;
    }

    /**
     * 读集中认证的分支
     * @param bool $center_auth_n_only 是否只显示集中认证的N网点
     */
    public function get_center_auth_branch_info($center_auth_n_only = false) {
        $center_auth_map = array_flip($this->sc_disaster_group_model->getCenterAuthBranch($center_auth_n_only));
        $branch_raw = $this->get_branch_list();
        $center_auth_list = array();
        foreach ($center_auth_map as $key => $val) {
            if(isset($branch_raw[$key]))
            {
                $center_auth_list[$key] = array(
                    'id' => $key,
                    'name' => $branch_raw[$key]['name'],
                );
            }
        }
        return  $center_auth_list;
    }

    /**
     * 读取分布式认证的分支，wyq
     * @return $distbt_auth_list array 分布式认证的分支数组
     */
    public function get_distbt_auth_branch_info()
    {
        $distbt_auth_map = $this->get_auth_type_branch_map();
        $branch_raw = $this->get_branch_list();
        $distbt_auth_list = array();
        foreach ($distbt_auth_map as $key => $val) {
            if($val === \wns\branch_auth_style::DISTBT_AUTH && isset($branch_raw[$key]))
                {
                    $distbt_auth_list[$key] = array(
                        'id' => $key,
                        'name' => $branch_raw[$key]['name'],
                    );
                }
            }
            return  $distbt_auth_list;
        }

    /**
     * 读取center_branch_list.xml
     * @return array
     */
    public function readCenterBranchListConf()
    {
        $rs = array_from_xml_file($this->_center_branch_info, 'wns.center_branch_list');
        if (is_null($rs) || -1 === $rs) {
            bug(__('unexpected_config'));
        }
        $data = [];
        foreach ($rs['branch_list'] as $key=>$val)
        {
            $data[$val['account_id']] = $val;
        }
        return $data;
    }

    /**
     * 获取分支认证方式map
     * @return array
     * @throws Exception
     */
    public function get_auth_type_branch_map()
    {
        $msgs = new \wns\center_branch_list();
        if (!$this->_read_protobuf_from_xml($msgs->descriptor()->getName(), $msgs, $this->_center_branch_info)) {
            bug(__('unexpected_config'));
        }
        $info = array();
        $auth_center_map = $this->get_center_auth_branch_map();
        foreach($msgs->getBranchListList() as $val)
        {
            $id = $val->getAccountId();
            $info[$id] = isset($auth_center_map[$id])?\wns\branch_auth_style::CENTER_AUTH:\wns\branch_auth_style::DISTBT_AUTH;
        }
        return $info;
    }

    /**
     * 获取集中认证分支map
     * @return array|bool
     */
    public function get_center_auth_branch_map()
    {
        $auth_center_map = array_flip($this->sc_disaster_group_model->getCenterAuthBranch());
        return $auth_center_map;
    }

    // --------------------------------------------------------------------

    /**
     * 通知双机同步分支AP目录/wns/etc/config/wac/branch/
     *
     * @return      bool
     */
    protected function notify_ha()
    {

        //修改同步文件  让文件夹在双机同步
        $msg = new \wns\dir_chg_ha();
        $this->_read_protobuf_from_xml($msg->descriptor()->getName(), $msg, self::HA_BRANCH_FILE);
        $data = $this->_conv_msgObj_to_array($msg);
        $data['key']=isset($data['key'])?(++$data['key']):1;
        $this->_conv_array_to_msgObj($msg, $data);
        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, self::HA_BRANCH_FILE);
    }


    /**
     * 托管分支修改，对应引用的配置也需要同步更新，单个配置列表的修改
     * @param $input_conf_list              待修改配置列表
     * @param $deposit_ids                  最新托管分支id，为null表示不修改托管信息，只处理删除
     * @param $all_index                    对应配置所有接入点的标记字段，比如wlan的all_group
     * @param $grp_index                    对应配置中AP组id的字段，比如wlan的group_id
     * @param string $branch_list_index     对应配置中分支list的字段
     * @param string $bid_index             对应配置中分支id的字段
     * @param string $ball_index            对应配置中分支所有的字段
     * @param string $bgrp_index            对应配置中分支分组的字段
     * @param string $callback              判断单条记录是否要更新的回调函数
     * @return bool
     */
    private function update_one_config(&$input_conf_list, $deposit_ids, $all_index, $grp_index,$branch_list_index='branch_list',$bid_index='branch_id',$ball_index='is_all_grp',$bgrp_index='group_id',$callback='_is_update')
    {
        static $center_apg = null;
        static $branch_root_apgid = null; //所有分支的“所有区域”的id
        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");

        if(is_null($center_apg))
        {
            $this->wl_apgroup_model->set_branch_id(CENTER_ID);
            $center_apg = $this->wl_apgroup_model->get_all_apgroups(false);
        }
        if(is_null($branch_root_apgid))
        {
            $branch_root_apgid = $this->wl_apgroup_model->get_branch_root_id();
        }
        //配置列表遍历更新托管分支信息
        foreach($input_conf_list as $key => &$val)
        {
            if($all_index === 'sellpush_all_group') //标记是推广规则
            {
                $all_index = 'all_group';
                $bakval = $val;
                $val = $val['condition']['ap'];
            }
            if(!$this->$callback($val))
            {
                goto BAKUP;
            }
            $add_deposit_grp = array();
            //配置选择了所有中心端接入点，则该配置不需要更新，默认包含了托管分支的AP配置
            if(isset($val[$all_index]) && $val[$all_index])
                goto BAKUP;
            //没有配置分支也不需要处理
            if(!isset($val[$branch_list_index]) || empty($val[$branch_list_index]))
                goto BAKUP;
            //将配置中托管分支的AP组数据加入到$add_deposit_grp
            foreach($val[$branch_list_index] as $bkey => $branch)
            {
                if(isset($deposit_ids) && isset($deposit_ids[$branch[$bid_index]]))
                {
                    if($branch[$ball_index])
                    {
                        $add_deposit_grp[] = $branch_root_apgid[$branch[$bid_index]];
                    }
                    else
                    {
                        $add_deposit_grp = array_merge($add_deposit_grp, $branch[$bgrp_index]);
                    }
                }
                if(isset($this->_delete_ids[$branch[$bid_index]])) //删除分支，这里需要删除配置
                {
                    unset($val[$branch_list_index][$bkey]);
                }
            }
            if(isset($deposit_ids)) //为null时不处理托管，只处理删除分支的情况
            {
                //将中心端的AP组（group_id）中，非中心端的AP组id（旧的托管分支）去掉
                if(isset($val[$grp_index]) && !empty($val[$grp_index]))
                {
                    foreach($val[$grp_index] as $i => $grpid)
                    {
                        if(!isset($center_apg[$grpid])) //不属于中心端自身配置，先unset掉
                        {
                            unset($val[$grp_index][$i]);
                        }
                    }
                }
            }
            //将新的托管分支数据加进来
            if(isset($deposit_ids) && !empty($add_deposit_grp))
            {
                if(!isset($val[$grp_index]))
                {
                    $val[$grp_index] = $add_deposit_grp;
                }
                else
                {
                    $val[$grp_index] = array_merge($val[$grp_index], $add_deposit_grp);
                }
            }
            if(empty($val[$branch_list_index]))
            {
                unset($val[$branch_list_index]);
            }
            if(empty($val[$grp_index]))
            {
                unset($val[$grp_index]);
            }
            BAKUP:
            if(isset($bakval))
            {
                $bakval['condition']['ap'] = $val;
                $val = $bakval;
                //$all_index === 'sellpush_all_group'; //无效代码，现将其注释. lyj 2017/09/20
                unset($bakval);
            }
        }
        return true;
    }

    /**
     * 托管是否更新此记录(默认回调函数，不可删！)
     * @return bool
     */
    protected function _is_update($record)
    {
        if(empty($record) || !is_array($record))
            return false;
        return true;
    }

    /**
     * 检查wlan规则是否是配的ap组
     * @param $record
     * @return bool
     */
    protected function _is_update_wlan_rule($record)
    {
        if(isset($record['attr_type'])
            && $record['attr_type']==\wns\wlan_rule_attr_type_e::ATTR_TYPE_LOCATION
            && $record['attr'] == \pkg\form\wlan\SourceAttrComboBox::LOCAL_AP_GROUP)
        {
            return true;
        }
        return false;
    }

    protected function get_loop_record_id()
    {
        $id = $this->_max_id + 1;
        $recordcnt = count($this->_used_idset);
        if($recordcnt >= self::MAC_ID_CNT)
            {
                bug(__('分支个数不能超过上限:%d。', self::MAC_ID_CNT));
            }
        while(isset($this->_used_idset[$id]) || $id > self::MAC_ID_CNT) //个数达到
        {
            $id++;
            if($id > self::MAC_ID_CNT) //8192后id就回环，id=0保留给中心端用的。
            {
                $id = 1;
            }
        }
        $this->_max_id = $id;
        $this->_new_idset[] = $id;
        $this->_used_idset[$id] = $id;
        return $id;
    }

    /**
     * 托管分支修改，对应引用的配置也需要同步更新
     */
    private function update_config_after_deposit_change($deposit_ids)
    {
        //wlan配置、AP有线认证需要同步更新
        require_once(APPPATH . 'third_party/proto/conf/wns_cfg_wl_wlan.php');
        $wlan_lan_conf = array(
            '/wns/etc/config/wac/wns_cfg_wl_wlan_ui.xml',
            '/wns/etc/config/wac/wns_cfg_wl_ap_wired_ui.xml'
        );
        foreach($wlan_lan_conf as $conf)
        {
            $rs = array_from_xml_file($conf, 'wns.cfg_wlan_list');
            if (is_null($rs) || -1 === $rs)
            {
                bug(__('unexpected_config'));
            }
            if(!empty($rs['wlan_list']))
            {
                $this->update_one_config($rs['wlan_list'], $deposit_ids, 'all_group', 'group_id');
                foreach($rs['wlan_list'] as &$row)
                {
                    if(isset($row['wlan_permission']['rule_list'])){
                        foreach($row['wlan_permission']['rule_list']  as &$attr){
                            if(isset($attr['attr_list']))
                            {
                                $this->update_one_config($attr['attr_list'], $deposit_ids,'rule_value_any', 'value','branch_list','branch_id','rule_value_any', 'value','_is_update_wlan_rule');
                            }
                        }
                    }
                    if(isset($row['wlan_guest_auth']['guest_role_rule']['rule_list'])){
                        foreach($row['wlan_guest_auth']['guest_role_rule']['rule_list'] as &$attr){
                            if(isset($attr['attr_list']))
                            {
                                $this->update_one_config($attr['attr_list'], $deposit_ids,'rule_value_any', 'value','branch_list','branch_id','rule_value_any', 'value','_is_update_wlan_rule');
                            }
                        }
                    }
                    if(isset($row['portal_page_rules']['rule_list'])){
                        foreach($row['portal_page_rules']['rule_list'] as &$attr){
                            if(isset($attr['attr_list']))
                            {
                                $this->update_one_config($attr['attr_list'], $deposit_ids,'rule_value_any', 'value','branch_list','branch_id','rule_value_any', 'value','_is_update_wlan_rule');
                            }
                        }
                    }

                }
            }
            $rs = array_to_xml_file('wns.cfg_wlan_list', $rs, $conf);
            if (0 !== $rs)
            {
                $str = __('config_unwritable');
                $this->log->add('debug', array($str, $conf));
                bug($str);
            }
        }
        //四个推广规则配置需要同步更新
        require_once(APPPATH . 'third_party/proto/conf/wns_sell_push.php');
        if(is_center_wac())
        {
            $sell_push_conf['wns.sell_known_rules'] = '/wns/etc/config/wac/sc_wns_sell_push_known_ui.xml';
            $sell_push_conf['wns.sell_keyword_rules'] = '/wns/etc/config/wac/sc_wns_sell_push_keyword_ui.xml';
            $sell_push_conf['wns.sell_online_rules'] = '/wns/etc/config/wac/sc_wns_sell_push_online_ui.xml';
            $sell_push_conf['wns.sell_unknown_rules'] = '/wns/etc/config/wac/sc_wns_sell_push_unknown_ui.xml';
        }
        else
        {
            $sell_push_conf['wns.sell_known_rules'] = '/wns/etc/config/wac/wns_sell_push_known_ui.xml';
            $sell_push_conf['wns.sell_keyword_rules'] = '/wns/etc/config/wac/wns_sell_push_keyword_ui.xml';
            $sell_push_conf['wns.sell_online_rules'] = '/wns/etc/config/wac/wns_sell_push_online_ui.xml';
            $sell_push_conf['wns.sell_unknown_rules'] = '/wns/etc/config/wac/wns_sell_push_unknown_ui.xml';
        }
        foreach($sell_push_conf as $fileflag => $conf)
        {
            $rs = array_from_xml_file($conf, $fileflag);
            if (is_null($rs) || -1 === $rs)
            {
                bug(__('unexpected_config'));
            }
            if(!empty($rs['item']))
            {
                $this->update_one_config($rs['item'], $deposit_ids, 'sellpush_all_group', 'group_id');
            }
            $rs = array_to_xml_file($fileflag, $rs, $conf);
            if (0 !== $rs)
            {
                $str = __('config_unwritable');
                $this->log->add('debug', array($str, $conf));
                bug($str);
            }
        }

        //灾备策略域
        require_once(APPPATH . 'third_party/proto/conf/wns_cfg_wl_ap_disaster.php');
        if(is_center_wac())
            $conf = '/wns/etc/config/wac/sc_wns_cfg_control_disaster_ui.xml';
        else
            $conf = '/wns/etc/config/wac/wns_cfg_control_disaster_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.cfg_ap_disaster_list');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['ap_disaster_list']))
        {
            $this->update_one_config($rs['ap_disaster_list'], $deposit_ids, null, 'apg_id');
        }
        $rs = array_to_xml_file('wns.cfg_ap_disaster_list', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }

        //无线负载域
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_ap_blance_list.php');
        if(is_center_wac())
            $conf = '/wns/etc/config/wac/sc_wns_cfg_ap_blance_list_ui.xml';
        else
            $conf = '/wns/etc/config/wac/wns_cfg_ap_blance_list_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.BlanceList');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['blance_rule']))
        {
            $this->update_one_config($rs['blance_rule'], $deposit_ids, null, 'group_id');
        }
        $rs = array_to_xml_file('wns.BlanceList', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }
        //接入点升级
        require_once(APPPATH.'third_party/proto/conf/ap_upg_mission.php');
        $conf = '/wns/etc/config/wac/ap_upg_mission_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.ap_mission_list');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['ap_mission_list']))
        {
            $this->update_one_config($rs['ap_mission_list'], $deposit_ids, 'is_all_ap', 'ap_group_list');
        }
        $rs = array_to_xml_file('wns.ap_mission_list', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }

        //无线射频防护
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_widspolicy.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_common_enum.php');
        if(is_center_wac())
            $conf = '/wns/etc/config/wac/sc_wns_cfg_widspolicy_ui.xml';
        else
            $conf = '/wns/etc/config/wac/wns_cfg_widspolicy_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.WidsPolicyList');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['policy']))
        {
            $this->update_one_config($rs['policy'], $deposit_ids, 'all_group', 'group_id');
        }
        $rs = array_to_xml_file('wns.WidsPolicyList', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }

        //接入点dhcp防御
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_trusted_dhcp.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_common_enum.php');
        if(is_center_wac())
            $conf = '/wns/etc/config/wac/sc_wns_cfg_trusted_dhcp_local_ui.xml';
        else
            $conf = '/wns/etc/config/wac/wns_cfg_trusted_dhcp_local_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.trusted_dhcp_t');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['range']))
        {
            $this->update_one_config($rs['range'], $deposit_ids, 'is_all_ap', 'group_id');
        }
        $rs = array_to_xml_file('wns.trusted_dhcp_t', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }

        //接入点网络安全
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_arp_isolate_usr_local.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_common_enum.php');
        require_once(APPPATH.'third_party/proto/conf/sc_common.php');
        if(is_center_wac())
            $conf = '/wns/etc/config/wac/sc_wns_cfg_arp_isolate_usr_local_ui.xml';
        else
            $conf = '/wns/etc/config/wac/wns_cfg_arp_isolate_usr_local_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.wns_ap_arp_isolate_usr_t');
        if (is_null($rs) || -1 === $rs)
        {
//            bug(__('unexpected_config'));
        }
        if(!empty($rs['trust_obj']))
        {
            $this->update_one_config($rs['trust_obj'], $deposit_ids, 'is_all_ap', 'group_id');
        }
        $rs = array_to_xml_file('wns.wns_ap_arp_isolate_usr_t', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
//            bug($str);
        }

        //定位服务器 —— 有问题，托管的定位服务器就不处理吧
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_3party_server.php');
        $conf = '/wns/etc/config/wac/sys_open_interface.xml';
        $rs = array_from_xml_file($conf, 'wns.location_server_list');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['srv_info']))
        {
            $this->update_one_config($rs['srv_info'], $deposit_ids, null, 'ap_list');
        }
        $rs = array_to_xml_file('wns.location_server_list', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($conf);
    }

    /**
     * 获取列表信息
     */
    public function get_uidebug_data($index) {
        require_once('/wns/webui/php_test_data.php');
        $this->data = get_php2ui_data($index);
        return $this->data;
    }

    public function preview()
    {
        set_time_limit(0);
        clearstatcache();
        $path = $this->_get_upload_file($this->_args['id']);
        $ret = array();
        $size_limit = (50*1024*1024);
        $num = 0;
        if(file_exist($path) && filesize($path) != 0)
        {
            $size =  filesize($path);
            if($size>$size_limit || $size<0 || $size === false ){
                bug(__('导入文件不能超过{0}M',50));
            }            
            $fp = fopen($path,'rb');
            $header = array('name','account','pwd','group','net_manage_type','model','gateway_sn',);
            $cnt = count($header);
            while($record = mb_fgetcsv($fp))
            {
                if (isset($record[0]) && 0 === strncmp($record[0], '#', 1)) {
                    continue;
                }
                $num++;
                if($num>self::PREVIEW_LIMIT){
                    continue;//
                }                
                if(count($record) !== $cnt)
                {
                    $record = array_pad_slice($record,$cnt,'',$cnt);
                }
                foreach($record as &$value){
                    $value = htmlentities($value); //转义 避免xss攻击
                }                
                $ret[] = array_combine($header,$record);
            }
            fclose($fp);
        }else{
            bug(__('请重新选择上传文件'));
        }
        $ret['total'] = $num;
        return $ret;
    }


    protected function _handle_upload_record(array $record)
    {
        $this->load->model('sys_configure/central_monitor/central_area_model');
        if (is_empty($record['group']))
        {
            $record['group_id'] = $this->central_area_model->get_default_group_id(); //获取默认配置的id
        }
        else //组是否存在
        {
            if (false === $this->Fv->check_text($record['group']))
            {
                bug(__('check_text', __('分支分组')));
            }
            $group_id = $this->central_area_model->auto_create_group($record['group']);
            if ($group_id !== false) {
                $record['group_id'] = $group_id;
            }
        }
        if(empty($record['net_manage_type']))
        {
            $record['net_manage_type'] = \wns\net_manage_e::BRANCH_MANAGE;
        }
        if(!empty($record['model']))
        {
            $model = $this->get_conf_model($record['model']);
            if(is_null($model))
                bug( __('设备型号不正确'));
            unset($record['model']);
            $record['model'] = array(
                'text' => $model,
            );
        }
        return $record;
    }

    public function _parse_branch(array &$record)
    {
        if(false === $this->Fv->required($record['name']))
        {
            bug(__('required', __('分支名称')));
        }
        if(false === $this->Fv->required($record['account']))
        {
            bug(__('required', __('账号')));
        }
        if(false === $this->Fv->required($record['pwd']))
        {
            bug(__('required', __('密码')));
        }
        if(false === $this->Fv->check_text($record['name']))
        {
            bug(__('check_text', __('分支名称')));
        }

        if(false === $this->Fv->check_account($record['account']))
        {
            bug(__('check_account', __('账号')));
        }
        if(false === $this->Fv->check_sshpwd($record['pwd']))
        {
            bug(__('check_key', __('密码')));
        }
        if(!empty($record['net_manage_type']))
        {
            if(intval($record['net_manage_type']) !== \wns\net_manage_e::BRANCH_MANAGE &&
                intval($record['net_manage_type']) !== \wns\net_manage_e::CENTER_MANAGE)
            {
                bug( __('网络管理模式不正确'));
            }
        }
        if(false === $this->Fv->check_gateway_sn($record['gateway_sn'], true))
        {
            bug(__('check_gateway_sn', __('网关序号')));
        }
    }

    public function import()
    {
        $path = $this->_get_upload_file($this->_args['id']);
        $recordset_bak = $this->_recordset;
        $errorfilename = 'branch_detail'.date('YmdHis').random_string('numeric',10).'.csv';
        $errorfile = rtrim(config_item('temp_folder'), '/').'/'.$errorfilename;
        if(file_exist($path) && filesize($path) != 0)
        {
            $fp = fopen($path,'rb');
            $efp = fopen($errorfile,'w+');
            $header = array('name','account','pwd','group','net_manage_type','model', 'gateway_sn',);
            $cnt = count($header);
            $errnum = config_item('errmsg_limit');
            $num = $line = $sucess = $error =0;
            $begin = $this->_max_id + 1;
            while($record = mb_fgetcsv($fp))
            {
                try
                {
                    ++$line;
                    if (isset($record[0]) && 0 === strncmp($record[0], '#', 1))
                    {
                        continue;
                    }
                    ++$num;
                    if(count($record) !== $cnt)
                    {
                        $record = array_pad_slice($record,$cnt,'',$cnt);
                    }
                    $form['data'] = array_combine($header, $record);
                    $form['data'] = $this->_handle_upload_record($form['data']);
                    $this->_parse_branch($form['data']);
                    $this->_args = $form;
                    $rs = $this->create(false);
                    if ($this->_import_exceed)
                    {
                        ++$error;
                        fputcsv($efp,array('#'.__('branch_exceed_uplimit', $this->_limit_branch)));
                        $remain = $this->_limit_branch - count($recordset_bak);
                        if ($remain > 0)
                        {
                            fputcsv($efp, array('#'.__('最多只能导入 {0} 个。', $remain)));
                        }
                        break;
                    }
                    ++$sucess;

                }
                catch(Exception $e)
                {
                    $errmsg = __('error_occur', $line, $e->getMessage());
                    ++$error;
                    array_push($record,$errmsg);
                    fputcsv($efp,$record);
                }


            }
            fclose($fp);
            fclose($efp);
            delete_file($path);

            if ($this->_import_exceed || 0!==$error)
            {
                //delete_file($path);
                $this->log->set_message('error',array());
                if (__FUNCTION__ === $this->_action)
                {
                    $this->addLog('controller_cluster', __('导入分支'), false);
                }
                $this->change_file_encode_shell($errorfile);
                $this->log->add('inform',__('user_import_detail',0,$error,$this->_import_exist));
                return array('path'=>$errorfilename);
            }else{
                if($sucess > 0)
                {
                    //td30758 先创建AP配置，才能创建交换机配置
                    $ret = $this->create_branch_conf('AP');
                    if($ret !== false)
                    {
                        $ret = $this->create_branch_conf('switch');
                    }
                    if($ret === false)
                    {
                        $this->addLog('controller_cluster', __('导入分支'), false);
                        if(!$this->log->has_error())
                        {
                            bug(__("获取数据失败，请检查服务是否已运行"));
                        }
                        return false;
                    }
                    $this->update_branch_inter_conf();
                    $this->update_branch_net_status_conf();
                    foreach($this->_new_idset as $branch_id)
                    {
                        $this->update_branch_lang($branch_id);
                    }
                }
                $rs = $this->central_area_model->write();
                $rs = $this->_write();
                if (__FUNCTION__ === $this->_action)
                {
                    if($rs)
                    {
                        $this->addLog('controller_cluster', __('导入分支'), true);
                    }else{
                        $this->addLog('controller_cluster', __('导入分支'), false);
                    }
                }
                return $rs;
            }

        }else{
            bug(__('请重新选择上传文件'));
        }
    }

    public function export()
    {
        set_time_limit(0);
        $this->load->helper('download');
        $name = 'BranchList'.date('Y-m-d',time()).'.csv';
        $file = rtrim(config_item('temp_folder'), '/').'/'.$name;
        $header = array('#'.__('网点名称'),__('账号'),__('密码'),__('网点分组'),__('网络管理模式'),
            __('设备型号'),__('网关序号'));
        $fp = fopen($file,'w+');
        fputcsv($fp,$header);
        $this->load->model('sys_configure/central_monitor/central_area_model');
        $area_map = $this->central_area_model->get_grpid_to_group_map();
        foreach($this->_recordset as $record)
        {
            unset($record['id']);
            $record['pwd'] = $this->pwdenc_model->pwd_dencypt($record['pwd']);
            $record['group_id'] = $area_map[$record['group_id']]['name'];
            $record['net_manage_type'] = isset($record['net_manage_type']) ? $record['net_manage_type'] : \wns\net_manage_e::BRANCH_MANAGE;
//            $record['platform'] = isset($record['platform']) && $record['platform'] === \wns\branch_platform_e::CLOUD ? __('云控制器') : __('实体控制器');
            if(isset($record['platform']))
                unset($record['platform']);
            if(isset($record['model']))
                $record['model'] = $this->get_model_ui_show($record['model']);
            if(isset($record['cloud_config']))
                unset($record['cloud_config']);
            if(isset($record['center_addr']))
                unset($record['center_addr']);
            fputcsv($fp,$record);
        }
        fclose($fp);
        $this->change_file_encode_shell($file);
        force_download($name,$file);
        parent::addLog('controller_cluster',__('导出分支'),true);
        @unlink($file);
        return true;

    }

    /**
     * 获取分支对应中心端连接信息
     * @return array
     */
    public function get_join_sc_info()
    {
        $infor = array();
        $sc = isset($this->_sc_info['join_sc'])?$this->_sc_info['join_sc']:array();
        if(empty($sc))
        {
            $infor = array(
                'account'=>'',
                'pwd'=>'',
                'center_addr'=>'',
                'bak_center_addr'=>'',
                'tenant_name'=>'',
            );
        }else{
            $infor = array(
                'account'=>$sc['account'],
                'pwd'=>$this->pwdenc_model->pwd_dencypt($sc['pwd']),
                'center_addr'=>$sc['center_addr'],
                'bak_center_addr' => isset($sc['bakup_center_addr']) ? $sc['bakup_center_addr'] : '',
                'tenant_name'=> isset($sc['mt_name'])?$sc['mt_name']:'',
            );
        }
        return $infor;
    }

    public function get_branchid_by_grp($group_id)
    {
        static $grp_branch_map = null;
        if(is_null($grp_branch_map))
        {
            foreach($this->_recordset as $val)
            {
                $grp_branch_map[$val['group_id']][] = $val['id'];
            }
        }
        return isset($grp_branch_map[$group_id]) ? $grp_branch_map[$group_id] : array();
    }

    //根据branch_id获取分支信息
    public function get_branch_info_by_id($id)
    {
        static $branch_infos = null;
        if (is_null($branch_infos)) {
            $this->get_real_branch_list();
            foreach ($this->_recordset as $key => $val) {
                $branch_infos[$val['id']] = $val;
            }
        }
        $id = intval($id);
        if(isset($branch_infos[$id]))
        {
            return $branch_infos[$id];
        }
        return null;
    }

    //$only_mgmt 只显示集中管理的分支
    public function get_branchinfo_by_grp($group_id, $only_mgmt = false)
    {
        static $grp_branch_map = null;
        if(is_null($grp_branch_map))
        {
            if($only_mgmt)
            {
                $this->get_real_branch_list();
            }

            foreach($this->_recordset as $val)
            {
                if(!$only_mgmt)
                {
                    $grp_branch_map[$val['group_id']][] = $val;
                    continue;
                }
                if(isset($val['mode']) &&
                    ($val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                        $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
                {
                    $grp_branch_map[$val['group_id']][] = $val;
                }
            }
        }
        return isset($grp_branch_map[$group_id]) ? $grp_branch_map[$group_id] : array();
    }

    //$filter_monitor代表是否过滤监控模式的分支
    //$filter_maintenance代表是否过滤维护模式的分支
    //$filter_center_auth_n代表是否过滤管理模式集中认证的N
    public function get_branchinfo_by_grp_new($group_id, $filter_monitor = false, $filter_maintenance = false, $filter_center_auth_n = false)
    {
        static $grp_branch_map = null;
        if(is_null($grp_branch_map))
        {
            $this->get_real_branch_list();

            foreach($this->_recordset as $val)
            {
                if(!isset($val['mode']))
                {
                    $grp_branch_map[$val['group_id']][] = $val;
                    continue;
                }
                else if($filter_monitor && $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE ||
                    $filter_maintenance && $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ||
                    $filter_center_auth_n && $val['is_center_auth_n'])
                {
                    continue;
                }
                $grp_branch_map[$val['group_id']][] = $val;  
            }
        }
        return isset($grp_branch_map[$group_id]) ? $grp_branch_map[$group_id] : array();
    }

    //$filter_monitor代表是否过滤监控模式的分支
    //$filter_no_status代表是否过滤无状态的分支
    //$filter_cloud_branch代表是否过滤云分支
    //$filter_offline 代表是否过滤离线分支
    public function get_branch_info_list($filter_monitor = false, $filter_no_status = false, $filter_cloud_branch = false, $filter_offline = false)
    {
        static $branch_map = null;
        if(is_null($branch_map))
        {
            $this->get_real_branch_list();
            $this->_replace();
            foreach($this->_recordset as $val)
            {
                if($filter_no_status && !isset($val['mode']))
                {
                    continue;
                }
                if($filter_monitor && $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE)
                {
                    continue;
                }
                if($filter_cloud_branch && $val['platform'] === \wns\branch_platform_e::CLOUD)
                {
                    continue;
                }
                if($filter_offline && $val['status'] === \wns\central_mgmt_stat_e::BRANCH_OFFLINE)
                {
                    continue;
                }
                $branch_map[] = array(
                    'id' => $val['id'],
                    'name'=> $val['name'],
                    'type'=> 'branch',
                    'leaf'=> true,
                    'platform'=>$val['platform'],
                    'version'=> isset($val['soft_version']) ? $val['soft_version'] : '1.0.0',
                );  
            }
        }
        return $branch_map;
    }

    /**
     * 判断分支是否开启高可用性
     * @param $id 分支id
     * @return bool
     */
    public function is_branch_enable_high_availability($id)
    {
        static $high_availability_branchs = null;
        if(is_null($high_availability_branchs))
        {
            $this->get_real_branch_list();
            foreach($this->_recordset as $val)
            {
                if(isset($val['master_slave_stat']) && $val['master_slave_stat'] !== \wns\master_slave_stat_e::SINGLE_HOST)
                    {
                        $high_availability_branchs[$val['id']] = array(
                            'id' => $val['id'],
                            'name'=> $val['name'],
                        );  
                    }

                }
            }
            return isset($high_availability_branchs[$id]) ? true : false;
        }

        public function get_branch_path_by_id($id)
        {
            static $branchs_map = null;
            if(is_null($branchs_map))
            {
                foreach ($this->_recordset as $key => $val) {
                    $branchs_map[$val['id']] = $val;
                }
 /*           $branchs_map[CENTER_ID] = array(
                'id' => CENTER_ID,
                'name' => __('本地控制器'),
                'group_id' => 1,
            );*/
        }
        $this->load->model('sys_configure/central_monitor/central_area_model');
        if(!isset($branchs_map[$id]))
            return;
        $grppath = $this->central_area_model->get_path_by_grpid($branchs_map[$id]['group_id'], true);
        if($grppath !== '/')
            $grppath = $grppath. '/'. $branchs_map[$id]['name'];
        else
            $grppath = '/'. $branchs_map[$id]['name'];
        return $grppath;
    }

    /**
     * 获取父节点和子节点的map
     * @param null $id
     * @return bool|null
     */
    public function get_parent_child_map($id=null)
    {
        static $relation = null;
        if($relation === null)
        {
            $relation[CENTER_ID] = CENTER_ALL_GROUP_ID;
            foreach($this->_recordset as $key => $val)
            {
                $relation[$val['id']] = $val['group_id'];
            }
        }
        if($id !== null)
            return isset($relation[$id])?$relation[$id]:false;
        return $relation;
    }

    /**修改集中认证托管
     * @param $ids          分支IDS
     * @return bool
     * @throws Exception
     */
    public function modify_center_auth($ids)
    {
        $ids = is_array($ids)?$ids:array($ids);
        if(is_empty($ids))
            return true;
        $binfos = $this->get_branch_list();
        $alldeposit = $this->get_deposit_info();
        $deposit_branch_set = array();
        $ret = true;
        $this->load->model('sys_configure/central_monitor/central_area_model');
        foreach($ids as $id)
        {
            if(isset($binfos[$id])){
                $info = $binfos[$id];
            }else{
                $ret =  false;
                break;
            }
            if(isset($alldeposit['branch'][$id])){/*分支已存在*/
                continue;
            }
            $path = array();
            $this->central_area_model->get_path_ids_by_grpid($path,$info['group_id']);
            $is_deposit = array_intersect($alldeposit['bgrp'],$path);
            if(!empty($is_deposit))/*所在分组已存在*/
                continue;
            $alldeposit['branch'][] = $id;
        }

        if($ret)
        {
            $alldeposit['branch'] = array_unique($alldeposit['branch']);
            $rs = array(
                'deposit_grp_id' => $alldeposit['bgrp'],
                'deposit_account_id' => $alldeposit['branch'],
            );
            $rs = array_to_xml_file('wns.cfg_ap_deposit', $rs, $this->_deposit_conf);
            if (0 !== $rs)
            {
                $str = __('config_unwritable');
                $this->log->add('debug', array($str, $this->_deposit_conf));
                bug($str);
            }

            $this->load->model('php_config_model');
            $this->php_config_model->add($this->_deposit_conf);
            $deposit_branch_set = array_flip($alldeposit['branch']);
            $this->get_all_branchset_by_bgroup_for_deposit($alldeposit['bgrp'],$deposit_branch_set);
            $this->update_config_after_deposit_change($deposit_branch_set);
        }
        return $ret;
    }

    public function delete_branch_from_center_auth($ids)
    {
        $ids = is_array($ids)?$ids:array($ids);
        $rs = array_from_xml_file($this->_deposit_conf , 'wns.cfg_ap_deposit');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        $deposit_branch_set = array();
        if(isset($rs['deposit_account_id']))
        {
            foreach($ids as $val)
            {
                $index = array_search($val,$rs['deposit_account_id']);
                if(false !== $index)
                {
                    unset($rs['deposit_account_id'][$index]);
                }
            }
            $deposit_branch_set = array_flip($rs['deposit_account_id']);
        }
        $ret = array_to_xml_file('wns.cfg_ap_deposit', $rs, $this->_deposit_conf);
        if (0 !== $ret)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_deposit_conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_deposit_conf);
        if(isset($rs['deposit_grp_id']))
        {
            $this->get_all_branchset_by_bgroup_for_deposit($rs['deposit_grp_id'],$deposit_branch_set);
        }
        $this->update_config_after_deposit_change($deposit_branch_set);
    }

    public function get_branch_name_by_id($id)
    {
        static $branchs_name = null;
        if (is_null($branchs_name)) {
            foreach ($this->_recordset as $key => $val) {
                $branchs_name[$val['id']] = $val['name'];
            }
       //     $branchs_name[0] = __('中心控制器');
        }
        $id = intval($id);
        if(isset($branchs_name[$id]))
        {
            return $branchs_name[$id];
        }
        return null;
    }

    public function get_branch_cnt()
    {
        $branch['online_branch'] = $branch['offline_branch'] = 0;
        $wacrole = $this->get_wac_role();
        if($wacrole === 'center')
        {
            $this->load->model('sys_configure/central_monitor/central_area_model');
            $branchr = $this->central_area_model->get_all_right_branch();
            $replyobj = new \webui_msg\branch_basic_info_resp();
            $bincodec = new \DrSlump\Protobuf\Codec\Binary();
            $ret = php_wns_ipc_to_self(\wns\module_id_e::REALINFO_SRV, 0,
                \wns\webui_msgid_monitor_info_e::BRANCH_WAC_BASIC_STAT_INFO_REQ, "",
                \wns\webui_msgid_monitor_info_e::BRANCH_WAC_BASIC_STAT_INFO_RESP, 3);
            $branchonline = [];
            if(isset($ret['buf']))
            {
                $obj = $bincodec->decode($replyobj, $ret['buf']);
                $result = $obj->getBranchBasicInfo();
                if(!empty($result))
                {
                    foreach ($result as $key => $val) {
                        if($val->getMonitorStat()) //在线
                        {
                            $branchonline[$val->getAccountId()] = true;
                            $branch['online_branch']++;
                        }
                    }
                }
            }
            foreach($this->_recordset as $key => $val) {
                if(isset($branchr) && is_array($branchr) && !isset($branchr[$val['id']]))
                {
                    $this->_recordset_total--;
                    if(isset($branchonline[$val['id']]))
                    {
                        $branch['online_branch']--;
                    }
                }
            }
            $branch['offline_branch'] = $this->_recordset_total - $branch['online_branch'];
        }
        return $branch;
    }

    public function get_branch_status_recordset()
    {
        $this->get_real_branch_list();
        $this->_replace();
        $data = [];
        foreach($this->_recordset as $value){
            $data[$value['id']] = $value['status'];
        }
        return $data;
    }
    /**
     * 中心端获取网点网络配置管理方式
     */
    public function get_branch_net_manage_type($id)
    {
        foreach($this->_recordset as $value){
            if($value['id'] == $id)
                return $value['net_manage_type'];
        }
        bug(__('该分支不存在！'));
    }

    /**
     * 网点获取自身网络配置管理方式
     */
    public function get_self_net_manage_type()
    {
        return $this->_branch_record['net_manage_type'];
    }

    /**
     * 是否是中心端管理网点网络配置
     */
    public function is_center_manage_net_conf($id = CENTER_ID)
    {
        if($id === CENTER_ID)
        {
            if(\wns\net_manage_e::CENTER_MANAGE == $this->get_self_net_manage_type())
                return true;
        }
        else
        {
            if(\wns\net_manage_e::CENTER_MANAGE == $this->get_branch_net_manage_type($id))
                return true;
        }
        return false;
    }


    public function get_branch_stat_info()
    {
        $this->get_real_branch_list();
        $this->_replace();
        $data = ['online'=>0, 'offline'=>0];
        foreach($this->_recordset as $value){
            if($value['status'] === \wns\central_mgmt_stat_e::BRANCH_ONLINE){
                $data['online'] ++;
            }elseif($value['status'] === \wns\central_mgmt_stat_e::BRANCH_OFFLINE){
                $data['offline'] ++;
            }
        }
        return $data;
    }

    /**
     * 云控制器自动切换为SC
     * @return bool
     */
    public function autoSwitchSC()
    {
        $msg = new \wns\sc_info_t();
        $msg->setWacMode(\wns\wac_role_e::CENTER_E);
        $this->_sc_info_msg = $msg;
        $rs = $this->_write_sc_conf();
        log_message_r('error',"change wac role center");
        if(!$rs)
            return false;
        $msg = new \wns\branch_release_pwd();
        $pwd = uniqid();
        $pwd = $this->pwdenc_model->pwdenc($pwd);
        $msg->setPwd($pwd);
        $data = $this->_conv_msgObj_to_array($msg);
        $rs = array_to_xml_file('wns.branch_release_pwd', $data, $this->_global_pwd_conf);
        if (0 !== $rs)
        {
            log_message_r('error', __('配置保存失败 %s', $this->_global_pwd_conf));
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_global_pwd_conf));
            bug($str);
        }
        log_message_r('error',"write release password");
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_global_pwd_conf);
        return true;
    }

     /**
     * 获取某个分支的状态
     *
     */
     public function get_branch_status($id)
     {
        static $branch_status_infos = null;
        if (is_null($branch_status_infos)) {
            $this->get_real_branch_list();
            $this->_replace();
            foreach ($this->_recordset as $key => $val) {
                $branch_status_infos[$val['id']] = $val['status'];
            }
        }
        if(isset($branch_status_infos[$id]))
            return $branch_status_infos[$id];
        bug(__('record_unexist'));
    }

    /**
     * 判断分支是否在线
     *
     */
    public function is_branch_online($id = CENTER_ID)
    {
        if(strstr($this->_wac_role, "branch")) {
            $data = $this->listbranch();
            if(isset($data['data']['status']) && $data['data']['status'])
                return true;
            return false;
        }
        if($this->get_branch_status($id) === \wns\central_mgmt_stat_e::BRANCH_ONLINE)
            return true;
        return false;
    }

    /**
     * 判断分支是否离线
     *
     */
    public function is_branch_offline($id = CENTER_ID)
    {
        if($this->get_branch_status($id) === \wns\central_mgmt_stat_e::BRANCH_OFFLINE)
            return true;
        return false;
    }

    /**
     * 判断分支是否有状态
     *
     */
    public function has_branch_status($id)
    {
        $status = $this->get_branch_status(intval($id));
        if($status === \wns\central_mgmt_stat_e::BRANCH_ONLINE ||
            $status === \wns\central_mgmt_stat_e::BRANCH_OFFLINE)
            return true;
        return false;
    }

    /**
     * 获取本地控制器双机状态
     *
     */
    public function get_local_monitor_stat()
    {
        $this->load->model('system_management/high_availability/high_availability_model');
        if(!$this->high_availability_model->is_enable()['enable'])
            $status = \wns\master_slave_stat_e::SINGLE_HOST;
        else if($this->high_availability_model->check_high_availability_status())
            $status = \wns\master_slave_stat_e::MASTER_SLAVE_ALIVE;
        else
            $status = \wns\master_slave_stat_e::MASTER_SLAVE_DEAD;
        return $status;
    }

    /**
     * 通过分支id获取相应的docker id
     * @param int $branch_id 分支id
     * @return null
     */
    public function get_docker_id_by_branch_id($branch_id)
    {
        foreach($this->_recordset as $value) {
            if($value['id'] == $branch_id){
                return isset($value['cloud_config']['docker_id']) ? $value['cloud_config']['docker_id'] : null;
            }
        }
        return null;
    }

    /**
     * 更新本地控制器信息
     */
    public function modify_local_wac()
    {
        $record = array();
        $record['id'] = intval($this->_args['data']['id']);
        if ($record['id'] !== CENTER_ID || !$this->is_id_exist($record, $index))
        {
            bug(__('record_unexist'));
        }
        $this->_old_index = $index;
        $this->_old_record = $record_bak = $this->_recordset[$index];
        $args_bak = $this->_args;
        $rs = $this->update_local_wac(true, $record_bak);
    }

    /**
     * sc 获取branch目录分支网络配置信息
     *
     * @return      bool
     */
    public function get_branch_net_info()
    {
        require_once(APPPATH . 'third_party/proto/conf/wns_cfg_sc_info.php');
        $conf = $_REQUEST['sc_conf_folder'] . self::BRANCH_NET_ENABLED_CONF;
        $rs = array_from_xml_file($conf, 'wns.branch_network_config_status');
        if(is_null($rs) || -1 === $rs) {
            bug(__('unexpected_config'));
        }
        return $rs;
    }

    /**
     * sc 获取本地控制器名称
     *
     * @return      string
     */
    public function get_local_wac_name()
    {
        return isset($this->_local_wac_record['name']) ? $this->_local_wac_record['name'] : '';
    }


    /**
     * 解除绑定
     */
    public function unbind()
    {
        $record = array();
        $record['id'] = intval($this->_args['data']['id']);
        if (!$this->is_id_exist($record, $index))
        {
            bug(__('record_unexist'));
        }
        $this->get_real_branch_list();
        if(!isset($this->_recordset[$index]['device_name']))
        {
            bug(__('该分支没有绑定控制器'));
        }
        
        $sendobj = new \webui_msg\center_unbind_branch_req();
        $sendobj->setAccountId($this->_args['data']['id']);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $data = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0, 
        \wns\webui_msgid_sc_e::UNBIND_C, $req, \wns\webui_msgid_sc_e::UNBIND_R, 3); //发消息获取 
        if($data == -2) {
            bug(__('与服务通讯超时'));
        }
        if (isset($data['buf'])) 
        {
            $bincodec = new \DrSlump\Protobuf\Codec\Binary();
            $msg = $bincodec->decode(new \webui_msg\center_unbind_branch_resp(), $data['buf']);
            if (\webui_msg\unbind_result_e::UNBIND_SUCCESSED === $msg->getResult()) 
                {
                    parent::addLog('controller_cluster',__('分支 {0} 解除绑定控制器 {1}', $this->_recordset[$index]['name'], 
                        $this->_recordset[$index]['device_name']),true);
                    return true;
                }
            }
            parent::addLog('controller_cluster',__('分支 {0} 解除绑定控制器 {1}', $this->_recordset[$index]['name'], 
                $this->_recordset[$index]['device_name']),false); 
            return false;

        }

    /**
     * 查看历史绑定记录
     */
    public function get_bind_log()
    {
        if($this->_wac_role === CENTER)
        {
            if(isset($this->_args['data']['id']))
                $log_pre = '['. $this->_args['data']['id']. ']';
            else
                return array(__('无绑定记录'));
        }
        else
            $log_pre = '[0]';

        $arr = array();
        if(!$fp = fopen(self::SC_BINDLOG, 'r'))
            {
                return __('无绑定记录');
            }
            $pos=-2;
            $eof="";
            $n = self::SC_BINDLOG_CNT;
            while($n > 0)
            {
                while($eof != "\n")
                {
                    if(!fseek($fp, $pos, SEEK_END))
                    {
                        $eof=fgetc($fp);
                        $pos--;
                    }
                    else
                    {
                        break;
                    }
                }
                $str_tmp = fgets($fp);
                if(!$str_tmp)
                {
                    break;
                }
                if(stripos($str_tmp, $log_pre) !== false)
                {
                $arr[] = substr($str_tmp, strlen($log_pre));//$str_tmp去除一下前缀
                //$arr[] = $str_tmp;
                $n--;
            }
            $eof="";
        }
        if(empty($arr))
        {
            return array(__('无绑定记录'));
        }
        return $arr;
    }

    /**
     * 获取记录中第一个分支id
     */
    public function get_first_branch_id()
    {
        $this->_sort();
        $record_id = CENTER_ID;
        if(is_center_wac())
        {
            $this->get_real_branch_list(true);
            if(is_super_role())
            {
                $record_id = isset($this->_recordset[0]['id']) ? $this->_recordset[0]['id'] : CENTER_ID;
            }
            else
            {
                $right = $this->get_right_data();
                foreach($this->_recordset as $val)
                {
                    if(isset($right['branchset']) && isset($right['branchset'][$val['id']]))
                    {
                        $record_id = $val['id'];
                        break;
                    }
                }
            }
        }
        return $record_id;
    }

    /**
     * 获取本地转发的分支信息
     */
    public function get_local_forword_branch()
    {
        static $local_forword_branchs = null;
        if(is_null($local_forword_branchs))
        {
            $this->get_real_branch_list();
            foreach($this->_recordset as $val) {
                if(isset($val['transmit_mode']) && $val['transmit_mode'] == \wns\branch_transmit_mode_e::LOCAL_TRANSMIT)
                    {
                        $local_forword_branchs[$val['id']] = array(
                            'id' => $val['id'],
                            'name' => $val['name'],
                        );
                    }
                }
            }
            return $local_forword_branchs;

        }


    /**
     * 导出分支配置信息
     */
    public function export_data()
    {
        $record = array();
        $this->_args['data'] = json_decode($this->_args['data'][0], true);
        $data = $this->_args['data'];
        $this->_down_branch_ids = explode(',', $this->_args['id'][0]);
        $branch_names = ' ';
        $this->_export_prepare();
        foreach($this->_down_branch_ids as $id)
        {
            $record['id'] = intval($id);
            if (!$this->is_id_exist($record, $index) || $record['id'] === CENTER_ID)
            {
                bug(__('record_unexist'));
            }
            $record = $this->_recordset[$index];
            if(empty($record['model']))
            {
                bug(__('请设置网点 {0} 硬件型号', $record['name']));
            }
            if(empty($record['gateway_sn']))
            {
                bug(__('请设置网点 {0} 网关序号', $record['name']));
            }
            if(empty($data['controller_center_ip']))
            {
                bug(__('中心控制器地址不能为空'));
            }
            if($data['basic_config'] && !$data['interface_network_config'])
            {
                $is_only_export_basic = true;
            }
            else
            {
                $is_only_export_basic = false;
            }
            if(!isset($record['center_addr']) || $record['center_addr'] !== $data['controller_center_ip'])
            {
                $this->_recordset[$index]['center_addr'] = $data['controller_center_ip'];
                $this->_recordset[$index]['pwd'] = $this->pwdenc_model->pwd_dencypt($record['pwd']);
                $this->_args['data'] = $this->_recordset[$index];
                $this->update(true);
                $this->update_branch_sc_info($this->_recordset[$index]);
            }
            $this->export_conf_dir = BRANCH_CONFIG_EXPORT_PAHT . $record['id'] . '/';
            build_dir($this->export_conf_dir);  
            $this->encrpy_config($index, $is_only_export_basic);
            $this->tar_config($index);
            $branch_names .= $record['name'] . ' ';
        }
        
        $this->load->helper('download');
        $filename =  sprintf('config_%s_%s.tar.gz', date('Ymdhis'), rand(1,10000));
        $file = BRANCH_CONFIG_EXPORT_PAHT . $filename;
        $cmd = sprintf('cd %s;tar -czf %s * -C %s', BRANCH_CONFIG_EXPORT_PAHT, $file, BRANCH_CONFIG_EXPORT_PAHT);
        $this->exec($cmd, $output, $code, 10);
        if($code != 0)
            bug(__('打包分支{0}配置失败', $branch_names));
        force_download($filename, $file); 
        $this->addLog('controller_cluster',__('下载分支{0}配置文件', $branch_names), true);   
        return true;

    }

    protected function _export_prepare()
    {
        $cmd = sprintf('rm -rf %s* ', BRANCH_CONFIG_EXPORT_PAHT);
        $this->exec($cmd);
    }


    /**加密分支配置
     * @param $index 记录指数
     * @param $is_only_export_basic 是否只导出基本配置
     */
    public function encrpy_config($index, $is_only_export_basic)
    {
        $record = $this->_recordset[$index];
        $conf = $this->configs['conf_folder'] . 'branch/' . $record['id'] . '/';  
        if($is_only_export_basic)
        {   
            $raw_files = [
                $conf . 'wns_cfg_sc_info.xml',
            ];
        }
        else
        {
            $raw_files = [
                $conf . 'wns_cfg_sc_info.xml',
                $conf . 'interfaces_p.xml',
                $conf . 'aggregation.xml',
                $conf . 'interfaces_v.xml',
                $conf . 'staticroute.xml',
                $conf . 'network_nat.xml',
                $conf . 'wns_cfg_policyroute.xml',
                $conf . 'wns_cfg_ip_group_local.xml',
                $conf . 'wns_cfg_snat_pool.xml',
                $conf . 'dns.xml',
                $conf . 'wns_cfg_system_hosts.xml'
            ];
        } 
        $aes_key = $record['gateway_sn'] . self::DEFAULT_AES_ENCRYPT_KEY_SUFFIX;
        $aes_key = substr($aes_key, 0, self::DEFAULT_AES_ENCRYPT_KEY_LEN);  
        foreach ($raw_files as $key => $val) {          
            $cmd = sprintf('cp -a %s %s', $val, $this->export_conf_dir);
            $this->exec($cmd, $output, $code);  
        }
        $ret = wns_net_inter_aes_encrypt(intval($record['id']), (int)$is_only_export_basic, $aes_key);
        if(is_null($ret))
        {
            $this->addLog('controller_cluster',__('下载分支{0}配置文件', $branch_names), false);   
            bug(__('下载分支 {0} 配置失败', $record['name']));
        } 
        return true;
    }

    public function tar_config($index)
    {
        $record = $this->_recordset[$index];
        $raw_str = $record['gateway_sn'] . self::FILE_NAME_ENCRYPT_SUFFIX;
        $cmd = sprintf('/wns/sbin/md5enc "%s"', $raw_str);
        $enc_str = exec($cmd);
        $model = $this->get_model_ui_show($record['model']);
        $this->export_name = sprintf('%s@%s@%s@%s.tar.gz', $record['name'], $enc_str, date('Ymdhis'), rand(1,10000));
        $this->export_file = $this->export_conf_dir . '/' . $this->export_name;
        $cmd = sprintf('cd %s;tar -czf %s * -C %s', $this->export_conf_dir, $this->export_file, $this->export_conf_dir);
        $this->exec($cmd, $output, $code, 10);
        if($code != 0)
        {
            //可能由于名称含有特殊字符导致打包失败，重命名文件名，重新打包一次
            $this->export_name = sprintf('%s@%s@%s@%s.tar.gz', $record['account'], $enc_str, date('Ymdhis'), rand(1,10000));
            $this->export_file = $this->export_conf_dir . '/' . $this->export_name;
            $cmd = sprintf('cd %s;ls |grep -v xml | xargs rm -f;tar -czf %s * -C %s', $this->export_conf_dir, $this->export_file, $this->export_conf_dir);
            $this->exec($cmd, $output, $code, 10);
            if($code != 0)
                bug(__('打包分支 {0} 配置失败', $record['name']));
        }
        //如果同时下载多个分支配置，将打包文件放BRANCH_CONFIG_EXPORT_PAHT目录
        $cmd = sprintf('mv %s  %s; rm -rf %s', $this->export_file, BRANCH_CONFIG_EXPORT_PAHT, $this->export_conf_dir);
        $this->exec($cmd, $output, $code, 10);
        return true;
    }

    /**
     * 显示控制器型号列表
     */
    public function list_wachd()
    {
        $hdinfo = parse_ini_file (WAC_HD_VER_INFO_FILE, true, INI_SCANNER_RAW);
        $hd_sangfor=array();
        $hd_sundray=array();
        $hd_abroad=array();
        $index = 0;
        if($hdinfo)
        {
            foreach($hdinfo as $key=>$item)
            {
                if(isset($item['devicetype']) && $item['devicetype'] !== 'WAC')
                    continue;
                isset($item['sangfor']) && $hd_sangfor[$index] = array(
                    'text' => $key, 
                    'value' => $item['sangfor'], 
                    'is_high' => isset($item['highdevice']) && $item['highdevice'] == 1 ? true : false,);
                isset($item['sundray']) && $hd_sundray[$index] = array(
                    'text' => $key, 
                    'value' => $item['sundray'], 
                    'is_high' => isset($item['highdevice']) && $item['highdevice'] == 1 ? true : false,);
                isset($item['abroad']) && $hd_abroad[$index] = array(
                    'text' => $key, 
                    'value' => $item['abroad'], 
                    'is_high' => isset($item['highdevice']) && $item['highdevice'] == 1 ? true : false,);
                $index ++;
            }
        }
        $mykey = 'value';
        $this->wachd_array_unique($hd_sangfor, $mykey);
        $this->wachd_array_unique($hd_sundray, $mykey);
        $this->wachd_array_unique($hd_abroad, $mykey);
        $company_type = get_company_type();
        switch ($company_type) {
            case COMPANY_SANGFOR:
            return $this->wachd_array_reindex($hd_sangfor);
            case COMPANY_ABROAD:
            return $this->wachd_array_reindex($hd_abroad);
            case COMPANY_SUNDRAY:
            return $this->wachd_array_reindex($hd_sundray);
            default :
            return $this->wachd_array_reindex($hd_sundray);
        }
    }


    private function wachd_array_unique(array &$arr, $kk)
    {
        $index = 0;
        $tmparr = array();
        foreach($arr as $key => $val)
        {
            if(in_array($val[$kk], $tmparr))
            {
                unset($arr[$key]);
            }
            else
            {
                $tmparr[$index] = $val[$kk];
                $index ++;
            }
        }
    }

    private function wachd_array_reindex(array $arr)
    {
        $temp_arr = array();
        foreach($arr as $key => $val)
        {
            $temp_arr[] = $val;
        }
        return $temp_arr;
    }

    /**
     * 获取配置中控制器型号获取ui显示的型号 例如：M5000 -- sangfor wac3100
     */
    public function get_model_ui_show($model)
    {
        $wachd = $this->list_wachd();
        foreach($wachd as $val)
        {   
            if($val['text'] === $model)
                return $val['value'];
        }
        return null;
    }

    /**
     * 根据ui显示的型号获取配置中的控制器型号  例如：sangfor wac3100 -- M5000
     */
    public function get_conf_model($model)
    {
        $wachd = $this->list_wachd();
        foreach($wachd as $val)
        {
            if($val['value'] === $model)
                return $val['text'];
        }
        return null;
    }

    /**
     * 更新分支接口配置
     */
    public function update_branch_inter_conf()
    {
        if(!empty($this->_inter_update_branch))
        {
            foreach($this->_inter_update_branch as $val)
            {
                if(empty($val['model']))
                    $def_interface_conf = '/wns/etc/default/wns/etc/config/wac/interfaces_p.xml';
                else
                    $def_interface_conf = '/wns/etc/default/wns/etc/config/wac/interfaces_p.xml.' . $val['model'];
                if(file_exists($def_interface_conf))
                {
                    $branch_interface_conf = $this->configs['conf_folder'] . 'branch/' . $val['id'] . '/interfaces_p.xml';
                    $cmd = sprintf('cp -a %s %s', $def_interface_conf, $branch_interface_conf);
                    $this->exec($cmd, $output, $code);
                    $cmd = sprintf('chown nobody:root %s;filesum -m %s', $branch_interface_conf, $branch_interface_conf);
                    $this->exec($cmd, $output, $code);
                }
            }
        }
    }

    /**
     * 更新分支网络状态配置
     */
    public function update_branch_net_status_conf()
    {
        if(!empty($this->_inter_update_branch))
        {
            foreach($this->_inter_update_branch as $val)
            {
                $branch_interface_conf = $this->configs['conf_folder'] . 'branch/' . $val['id'] . '/interfaces_p.xml';
                $branch_net_status_conf = $this->configs['conf_folder'] . 'branch/' . $val['id'] . '/branch_network_config_status.xml';
                if(file_exists($branch_interface_conf) && file_exists($branch_net_status_conf))
                {
                    $p_interface_info = array_from_xml_file($branch_interface_conf, 'wns.interfaces_p_list');
                    if(is_null($p_interface_info) || -1 === $p_interface_info) 
                    {
                        bug(__('unexpected_config'));
                    }
                    $branch_net_status_info = array_from_xml_file($branch_net_status_conf, 'wns.branch_network_config_status');
                    if(is_null($branch_net_status_info) || -1 === $branch_net_status_info) 
                    {
                        bug(__('unexpected_config'));
                    }
                    $branch_net_status_info['interface_num'] = count($p_interface_info['p_ifs']);
                    $branch_net_status_info['hwinfo'] = empty($val['model']) ? '' : $val['model'];
                    $branch_net_status_info['enable'] = empty($val['model']) ? false : true;
                    $rs = array_to_xml_file('wns.branch_network_config_status', $branch_net_status_info, $branch_net_status_conf);
                    if (0 !== $rs)
                    {
                        bug(__('config_unwritable'));
                    }
                }
            }
        }
    }


    /**
     * 判断分支是否是高端设备（m6500或者m7000）
     * @param    int   $id   分支id
     * @return   bool
     */
    public function is_high_equipment_by_id($id)
    {
        foreach($this->_recordset as $val) 
        {
            if($val['id'] === $id)
            {
                //m6500和m7000为高端设备
                if(!empty($val['model']) && $this->is_high_equipment_by_model($val['model']))
                    return true;
                else
                    return false;
            }
            
        }
        return false;
    }

    /**
     * 根据分支id获取设备型号
     * @param    int   $id   分支id
     * 
     */
    public function get_model_by_id($id)
    {
        foreach($this->_recordset as $val) 
        {
            if($val['id'] === $id)
            {
                //m6500和m7000为高端设备
                if(!empty($val['model']))
                    return $val['model'];
            }
        }
        bug(__('设备型号不存在'));
    }

     /**
     * 根据型号判断是否是高端设备
     */
    public function is_high_equipment_by_model($model)
    {
        $wachd = $this->list_wachd();
        foreach($wachd as $val)
        {
            if($val['text'] === $model && $val['is_high'])
                return true;
        }
        return false;
    }

    public function update_cloud_branch()
    {
        foreach($this->_recordset as $key => $record)
        {
            if(($record['platform'] === \wns\branch_platform_e::CLOUD) &&
                ($record['cloud_config']['docker_id'] === $this->_args['docker_id']))
            {
                $this->_recordset[$key]['cloud_config']['inside_ip'] = $this->_args['inside_ip'];
                if(!empty($this->_args['exit_ip']))
                    $this->_recordset[$key]['cloud_config']['exit_ip'] = $this->_args['exit_ip'];
                else
                    unset($this->_recordset[$key]['cloud_config']['exit_ip']);
                break;
            }
        }
        $rs = parent::update();
        if($rs)
        {
            $this->load->model('sys_configure/central_monitor/sc_disaster_group_model');
            $this->sc_disaster_group_model->update_all_cloud_addr();
            parent::addLog('controller_cluster', __('编辑分支账号 %s', $this->_args['docker_id']), TRUE);
        }
        else
        {
            parent::addLog('controller_cluster', __('编辑分支账号 %s', $this->_args['docker_id']), FALSE);
        }
        return TRUE;
    }

    public function assert_branch_master_online($branch_id)
    {
        $arr = array_column($this->_recordset, 'is_slave', 'id');
        if(isset($arr[$branch_id]))
            return !$arr[$branch_id];
        return true;
    }

    /**
     * 获取自身分支信息
     */
    public function get_self_branch_info()
    {
        return $this->_branch_record;
    }
}
